
#pragma warning(disable:4786)


#include "jbcdata.h"
#include "jbcjava.h"

#ifndef JBC_HEADER
#define JBC_HEADER

#define DEFAULT_FILE "array.dat"
#define RUNTIME_CLASS "RTClass.class"
#define MAX_ARRAYSIZE (100*1000)

//֐Xg
//jbc.cpp


//jbcmisc.cpp

//|C^n
void DeleteVarlist(Varlist* vl);
void DeleteExpression(Expression* e);
void DeleteStatement(Statement* s);
void DeleteFunction(Function *f);

//؍\o
void PrintExpression(Expression* e,string indent="");
void PrintVarlist(Varlist *vl);
void PrintType(Type *t);
void PrintStatement(Statement* s,string indent="",bool ShowLine=true);
void PrintFunction(Function *f);
string TypeToString(Type *t);

//ϐ`̏dh
bool CheckNameOverlap();
void CheckNameOverlap_Sub(Varlist* vl1,Varlist* vl2,Function* f);

//񂩂ΉϐE֐`擾
Variable* GetVariableFromString(string id,Function *f);
Function* GetFunctionFromString(string id);
int GetIndexfromIDList(vector<string>* sl,char* buf);
int GetVariableIDFromString(string id,Function *f);

//֐̏I[returnɂ
void AddReturn(Function *f);



//jbctype.cpp
bool CheckType();
void CheckType_VarArray(Varlist &vl,Function* f);
void CheckType_Statement(Statement *s,Function *f);
Type* CheckType_Expression(Expression *e,Function *f);
ConvTypeResult CheckConvType(Type *tf,Type *tt);
void CastExpression(Expression** e,Type *t);




//misc.cpp
template<typename T> T ChangeBO(T ti);
int utf16to8(unsigned char *to,unsigned short *from);
int utf8tosjis(char *to,const char *from);
int sjistoutf8(char *to,const char *from);

FuncVec* ParseClassFile(char* fn);
string CreateJavaTypeString(Function *pf);
string CreateJavaTypeString(Type *pt);
void PrintConstantPool(ConstantPool& cp);



//ϐXg
//jbc.cpp
extern vector<string> IDlist;	//ϐȂǂĂ
extern vector<string> Strlist; //萔Ă
extern string NowFunc;
extern ofstream ofs;
extern ConstantPool gcp;
extern FILE *parsefp;
extern string MyClassName,jbcfile;
extern Varlist* gVarlist; //O[oϐ
extern FuncVec gFunc,*RTFunc; //vO̊e֐Qyу^C֐
extern JFuncVec gJFunc;
extern StrVec ErrList;

extern int nowline;

#endif