
#ifndef JBC_DATA
#define JBC_DATA

#ifndef STL_INC
#define STL_INC
#include <map>
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>
#include <fstream>
#include <stdio.h>
using namespace std;
#endif


struct Type;
struct Variable;
struct Statement;
struct Expression;
struct Function;

//ϐ̃Xg
typedef	vector<Variable*> Varlist;

typedef vector<Statement*> StmtVec;
typedef vector<Expression*> ExprVec;
typedef vector<Function*> FuncVec;

typedef vector<string> StrVec;

#include "jbcparse.hpp"

//^
struct Type {
	int type; //T_INTT_VOIDT_FLOATT_STRING
	vector<int> arraydepth; //z̗vf
};

//ϐ
struct Variable {
	string name;
	Type type;
	bool local;
	int lineno;
	
	//l
	int ival;
	float fval;
	string sval;
};

//
struct Expression {
	int exprtype;	//T_IDƂT_CONSTƂT_OP2Ƃ
	int type;			//T_PLUSƂ
	Type etype;		//ꂪۂ̌^
	int lineno;
	ExprVec elist; //l̃Xg

	//lꍇ
	int ival;
	float fval;
	int index;
};

//
struct Statement {
	int stmttype; //T_IF
	int subtype; //̂Ƃgexit̂݁B
	int lineno;
	ExprVec exprlist;
	StmtVec stmtlist;
};


//֐
struct Function {
	string name;  //֐
	Type rettype; //Ԃl
	bool local;
	Varlist args; //Xg
	Varlist vl;		//֐̕ϐ`	
	int lineno[2];
	StmtVec plist; //vÕXg
};

//Zqe[u
struct OpTable{
	int index;
	char str[20];
};

static OpTable OPTable[]={
	{T_PLUS,"+"},
	{T_MINUS,"-"},
	{T_MULT,"*"},
	{T_DIV,"/"},
	{T_MOD,"%"},
	{T_LSHIFT,"<<"},
	{T_RSHIFT,">>"},
	{T_BITOR ,"|"},
	{T_BITAND,"&"},
	{T_BITXOR,"^"},
	{T_BITNOT,"!"},
	{T_BOOLOR,"||"},
	{T_BOOLAND,"&&"},
	{T_BOOLXOR,"^^"},
	{T_BOOLNOT,"!!"},
	{T_EQ,"="},
	{T_NE,"<>"},
	{T_LT,"<"},
	{T_LE,"<="},
	{T_GT,">"},
	{T_GE,">="},
	{T_NEG,"-"}
};


//ConvTypeŎgpԂl
enum ConvTypeResult {
	CT_CANT_CONV,
	CT_OK,
	CT_CONV
};


#endif