
#include "jbc.h"




bool Output_ExecuteFile(){
	Varlist::iterator vit;
	CPData cp;

	//܂ŒKvȂ̂o^Ă
	gcp.clear();
	//܂0Ԃ͐΂ɎgpȂ
	cp.tag=CP_CLASS;
	cp.ival[0]=1;
	gcp.push_back(cp);
	
	//t@C
	ConstantPool_Add(gcp,CP_UTF8,"SourceFile");
	ConstantPool_Add(gcp,CP_UTF8,jbcfile);

	//̃NX
	ConstantPool_Add(gcp,CP_CLASS,MyClassName,"",0,0);
	//X[p[NX<init>ǉ̎ɒǉ̂Ō

	//etB[h
	for(vit=gVarlist->begin();vit!=gVarlist->end();vit++){
		ConstantPool_Add(gcp,CP_FIELD,(*vit)->name,"",0,0);
		ConstantPool_Add(gcp,CP_UTF8,CreateJavaTypeString(&(*vit)->type),"",0,0);
	}	
		
	//CodeAgr[gǉ
	ConstantPool_Add(gcp,CP_UTF8,"Code");
	//LineNumberTableAgr[g
	ConstantPool_Add(gcp,CP_UTF8,"LineNumberTable");

	//ɃRXgN^Ȃǂo͂Ă
	Output_Constructor();

	if(ErrList.size()>0) return false;

	//e֐o
	for_each(gFunc.begin(),gFunc.end(),Output_Function);
	if(ErrList.size()>0) return false;
	
	//ŏIIȏo
	Output_ClassFile();
	if(ErrList.size()>0) return false;
	
	ofs << endl << "-----------------------------------" << endl;
	PrintConstantPool(gcp);
	ofs << "------------------------------------" << endl;
	ofs << "Success!" << endl;
	cout << "Success!" << endl;

	return true;
}

void Output_Constructor(){
	JavaAsmFunction *fInit,*fCInit;
	int i,j,ci,di;
	Varlist::iterator vit;

	//-----------------------------
	//<init>쐬
	//this|C^X^bNɐς
	
	fInit=new JavaAsmFunction;
	//aload_0
	//java.lang.Object.<init>
	//return
	
	AddJavaAsmStruct(fInit->vja,JO_aload_0);
	//java.lang.Object.<init>RX^gv[ɓo^Ă
	i=ConstantPool_Add(gcp,CP_METHOD,"<init>","java/lang/Object",0,0);
	AddJavaAsmStruct(fInit->vja,JO_invokespecial,"",i);
	AddJavaAsmStruct(fInit->vja,JO_return);
	
	fInit->f=NULL;
	fInit->name="<init>";
	gJFunc.push_back(fInit);

	//-----------------------------
	//<cinit>쐬
	//tB[h͑SstaticȂ̂ŁAvfw̔z͑SĂōs
	
	fCInit=new JavaAsmFunction;
	//z̏
	for(vit=gVarlist->begin();vit!=gVarlist->end();vit++){
		ci=di=0;
		for(i=0;i<(*vit)->type.arraydepth.size();i++){
			if((*vit)->type.arraydepth[i]==-1) di++;
			else ci++;
		}

		if(ci>0){
			if(di>0){
				//͂͂ȂEEE
				ErrList.push_back("err");
			}
			else{
				//萔X^bNɐςōs
				Output_CreateInitArray(fCInit->vja,*vit);
				//
				j=ConstantPool_Add(gcp,CP_FIELD,(*vit)->name,"",0,0);
				AddJavaAsmStruct(fCInit->vja,JO_putstatic,"",j,0);
			}
		}
		else if(di==0){
			//string̏ꍇ""ŏĂ
			if((*vit)->type.type==T_STRING){
				Output_CreateInitString(fCInit->vja);
				j=ConstantPool_Add(gcp,CP_FIELD,(*vit)->name,"",0,0);
				AddJavaAsmStruct(fCInit->vja,JO_putstatic,"",j,0);
			}
		}
	}

	return;

}



void Output_InitVariable(JavaAsmFunction *jf,Variable *v,int id){
	int i,ci,di;

	//z̏
	ci=di=0;
	for(i=0;i<v->type.arraydepth.size();i++){
		if(v->type.arraydepth[i]==-1) di++;
		else ci++;
	}

	if(ci>0){
		if(di>0){
			//͂͂ȂEEE
			ErrList.push_back("err");
			return;
		}
		else{
			//萔X^bNɐςōs
			Output_CreateInitArray(jf->vja,v);
		}
	}
	else if(di==0){
		//string̏ꍇ""ŏĂ
		if(v->type.type==T_STRING) Output_CreateInitString(jf->vja);
		else return;
	}
	else return;

	//
	if(id<4) AddJavaAsmStruct(jf->vja,(JavaOpecode)(id+(int)JO_astore_0),"",0,0);
	else if(id<0x100) AddJavaAsmStruct(jf->vja,JO_astore,"",id,0);
	else AddJavaAsmStruct(jf->vja,JO_wide,"",id,JO_astore);

}



//e֐o
void Output_Function(Function *f){
	int i,j;
	int labelcnt=0;
	JavaAsmFunction *jf;
	StmtVec::iterator sit;
	vector<string> for_label,do_label,loop_label;

	jf=new JavaAsmFunction;
	jf->f=f;
	jf->name=f->name;

	//܂֐RX^gv[ɓo^Ă
	ConstantPool_Add(gcp,CP_UTF8,f->name,"",0,0);
	ConstantPool_Add(gcp,CP_UTF8,CreateJavaTypeString(f),"",0,0);

	//KvȂ͕̂ϐ(IDKvȂ̂ŁAintŉ
	for(i=0;i<f->vl.size();i++)
		Output_InitVariable(jf,f->vl[i],i+f->args.size());

	//悤₭e֐Ă
	for(sit=f->plist.begin();sit!=f->plist.end();sit++)
		Output_Statement(*jf,*sit,labelcnt,loop_label,for_label,do_label);
	
	if(1){
		ofs << "-----------------------------------------------" << endl;
		ofs << "[Function ] - " << f->name << endl;
		if(1){
			ofs << endl << "[line table]" << endl;
			for(map<int,int>::iterator mit2=jf->la.begin();mit2!=jf->la.end();mit2++)
				ofs << mit2->first << " \t " << jf->vja[mit2->second].offset << endl;
		}

		ofs << endl << "[opecode]" << endl;
		for(i=0;i<jf->vja.size();i++){
			//xo
			for(map<string,int>::iterator mit=jf->label.begin();mit!=jf->label.end();mit++){
				if(mit->second==i)ofs << "::" << mit->first << " :" <<endl;
			}
		
			ofs << jf->vja[i].offset << "," << jf->vja[i].size << " - (" << hex << jf->vja[i].op << ")";
			for(j=0;j<sizeof(JOPTable)/sizeof(OpTable);j++){
				if(jf->vja[i].op==JOPTable[j].index){
					ofs << "\t" << JOPTable[j].str;
					break;
				}
			}

			ofs << "\t, " << dec << jf->vja[i].opi[0] << " , " << jf->vja[i].opi[1] << " , \"" << jf->vja[i].ops << "\"" << endl;
		}

	}



	
	gJFunc.push_back(jf);
	return;
}


//eXe[ggo^

void Output_Statement(JavaAsmFunction& jf,Statement *s,int &labelcnt,vector<string>& loop_label,vector<string>& for_label,vector<string>& do_label){
	Function *f;
	Variable *v;
	StmtVec::iterator sit;
	ExprVec::iterator eit;
	Expression *e;
	string st,label[6];
	char buf[256];
	int i,j,oldlabel;
	int sgn;

	//fobOp̍sԍƃAhX̑
	if(s->lineno>0) jf.la.insert(pair<int,int>(s->lineno,jf.vja.size()));
	
	switch(s->stmttype){
	//---------------------------------------------------------
	case T_CALL:
		//֐擾
		f=GetFunctionFromString(IDlist[s->exprlist[0]->index]);
		if(f==NULL){
			ErrList.push_back("err_call");
			return;
		}

		//eςōs
		for(eit=s->exprlist.begin()+1;eit!=s->exprlist.end();eit++)
			Output_Expression(jf,*eit,labelcnt);
		//֐Ăяo
		i=ConstantPool_Add(gcp,CP_METHOD,f->name);
		AddJavaAsmStruct(jf.vja,JO_invokestatic,"",i,0);

		//VOIDȊǑ^ł΁AԂlς܂̂łĂ
		if(f->rettype.type!=T_VOID)	AddJavaAsmStruct(jf.vja,JO_pop);

		break;

	//---------------------------------------------------------
	case T_REDIM:
		
		//ϐ擾
		f=jf.f;
		v=GetVariableFromString(IDlist[s->exprlist[0]->index],f);
		if(v==NULL){
			f=NULL;
			v=GetVariableFromString(IDlist[s->exprlist[0]->index],f);
		}
		if(v==NULL){
			ErrList.push_back("err_redim");
			return;
		}

		st="";
		//eςōs
		for(eit=s->exprlist.begin()+1;eit!=s->exprlist.end();eit++){
			st+="[";
			Output_Expression(jf,*eit,labelcnt);
		}

		if(v->type.arraydepth.size()==1){
			//1z
			if(v->type.type==T_INT) AddJavaAsmStruct(jf.vja,JO_newarray,"",10,0);
			else if(v->type.type==T_FLOAT) AddJavaAsmStruct(jf.vja,JO_newarray,"",6,0);
			else if(v->type.type==T_STRING){
				//NXw
				j=ConstantPool_Add(gcp,CP_CLASS,"java/lang/String","",0,0);
				AddJavaAsmStruct(jf.vja,JO_anewarray,"",j,0);
			}
			else{
				ErrList.push_back("err_redim");
				return;
			}
		}
		else{
			//2ȏ̏ꍇ
			if(v->type.type==T_INT) st+="I";
			else if(v->type.type==T_FLOAT) st+="F";
			else if(v->type.type==T_STRING) st+="Ljava/lang/String;";
			else{
				ErrList.push_back("err");
				return;
			}
			//NXw
			j=ConstantPool_Add(gcp,CP_CLASS,st,"",0,0);
			AddJavaAsmStruct(jf.vja,JO_multianewarray,"",j,v->type.arraydepth.size());
		}

		//ŌɓK؂put
		Output_Variable(jf.vja,v,f,JO_astore);
		
		break;

	//---------------------------------------------------------
	case T_SUBST:
		//ϐ擾
		f=jf.f;
		v=GetVariableFromString(IDlist[s->exprlist[0]->index],f);
		if(v==NULL){
			f=NULL;
			v=GetVariableFromString(IDlist[s->exprlist[0]->index],f);
		}
		if(v==NULL){
			ErrList.push_back("err_subst");
			return;
		}

		e=s->exprlist[0];

		//zȂϐς
		if(e->elist.size()>0){
			if(f){
				//[Jϐ
				i=GetVariableIDFromString(v->name,f);
				if(i<4) AddJavaAsmStruct(jf.vja,(JavaOpecode)(i+(int)JO_aload_0));
				else if(i<0x100) AddJavaAsmStruct(jf.vja,JO_aload,"",i);
				else AddJavaAsmStruct(jf.vja,JO_wide,"",i,JO_aload);
			}
			else{
				i=ConstantPool_Add(gcp,CP_FIELD,f->name);
				AddJavaAsmStruct(jf.vja,JO_getstatic,"",i,0);
			}
			//ɐςōs
			for(eit=e->elist.begin();eit!=e->elist.end();eit++){
				Output_Expression(jf,*eit,labelcnt);
				//ŌȊOaaload
				if(eit!=e->elist.end()-1) AddJavaAsmStruct(jf.vja,JO_aaload);
			}
		}

		//Ώۂ쐬
		Output_Expression(jf,s->exprlist[1],labelcnt);
		
		//
		if(e->elist.size()>=1){
			//zEStringȂaastore
			if(v->type.type==T_INT && e->elist.size()==v->type.arraydepth.size())
				AddJavaAsmStruct(jf.vja,JO_iastore);
			else if(v->type.type==T_FLOAT && e->elist.size()==v->type.arraydepth.size())
				AddJavaAsmStruct(jf.vja,JO_fastore);
			else AddJavaAsmStruct(jf.vja,JO_aastore);
		}
		else{
			//ʂ̕ϐ
			if(v->type.arraydepth.size()>0 || v->type.type==T_STRING)
				Output_Variable(jf.vja,v,f,JO_astore);
			else if(v->type.type==T_INT) Output_Variable(jf.vja,v,f,JO_istore);
			else if(v->type.type==T_FLOAT) Output_Variable(jf.vja,v,f,JO_fstore);
			else{
				ErrList.push_back("err_subst");
				return;
			}
		}

		break;

	//---------------------------------------------------------
	case T_EXIT:
		switch(s->stmttype){
		case T_DO:
			//EXIT DO
			if(do_label.empty()){
				sprintf(buf,"Error [%d]\tEXIT DODO̊OŎsĂ܂B",s->lineno);
				ErrList.push_back(buf);
				return;
			}
			//jump
			AddJavaAsmStruct(jf.vja,JO_goto,*(do_label.end()-1));
			break;
		case T_FOR:
			//EXIT FOR
			if(for_label.empty()){
				sprintf(buf,"Error [%d]\tEXIT FORFOR̊OŎsĂ܂B",s->lineno);
				ErrList.push_back(buf);
				return;
			}
			//jump
			AddJavaAsmStruct(jf.vja,JO_goto,*(for_label.end()-1));
			break;
		}
		break;
	
	//---------------------------------------------------------
	case T_CONTINUE:
		if(loop_label.empty()){
			sprintf(buf,"Error [%d]\tCONTINUE[vOŎsĂ܂B",s->lineno);
			ErrList.push_back(buf);
			return;
		}
		//jump
		AddJavaAsmStruct(jf.vja,JO_goto,*(loop_label.end()-1));
		break;

	//---------------------------------------------------------			
	case T_RETURN:
		if(jf.f->rettype.type==T_VOID){
			//SUBȂ畁ʂreturn
			AddJavaAsmStruct(jf.vja,JO_return);
		}
		else if(jf.f->rettype.type!=T_VOID && !s->exprlist.empty()){

			//ԂlvZ
			Output_Expression(jf,s->exprlist[0],labelcnt);
			//^CvɉĕԂl̎ނς
			f=jf.f;

			if(f->rettype.arraydepth.size()>0 || f->rettype.type==T_STRING)
				AddJavaAsmStruct(jf.vja,JO_areturn);
			else if(f->rettype.type==T_INT) AddJavaAsmStruct(jf.vja,JO_ireturn);
			else if(f->rettype.type==T_FLOAT) AddJavaAsmStruct(jf.vja,JO_freturn);
			else ErrList.push_back("err_return");
		}
		else{
			AddJavaAsmStruct(jf.vja,JO_aconst_null);
			AddJavaAsmStruct(jf.vja,JO_areturn);
		}


		break;
	//---------------------------------------------------------			
	case T_IF:
		label[0]="if_last."+string(itoa(labelcnt,buf,10));
		oldlabel=labelcnt++;

		for(i=0;i<s->exprlist.size();i++){
			//ȂΎ
			
			if(i==s->stmtlist.size()-1 && s->exprlist.size()==s->stmtlist.size()){
				//ɂȂȂŌ
				label[1]=label[0];
			}
			else{
				label[1]="if_next."+string(itoa(oldlabel,buf,10))+"."+string(itoa(i,buf,10));
			}

			if(s->exprlist[i]->exprtype==T_OP2 && s->exprlist[i]->type>=T_EQ && s->exprlist[i]->type<=T_GE){
				//ȗłꍇ
				Output_Expression(jf,s->exprlist[i]->elist[0],labelcnt);
				Output_Expression(jf,s->exprlist[i]->elist[1],labelcnt);
				Output_Branch(jf.vja,s->exprlist[i]->elist[0]->etype.type,s->exprlist[i]->type,false,label[1]);
			}
			else{
				Output_Expression(jf,s->exprlist[i],labelcnt);
				AddJavaAsmStruct(jf.vja,JO_ifeq,label[1]);
			}

			//IF̒go
			Output_Statement(jf,s->stmtlist[i],labelcnt,loop_label,for_label,do_label);

			//
			if(!(i==s->stmtlist.size()-1 && s->exprlist.size()==s->stmtlist.size())){
				//ɉȂIF̌ɃWv
				AddJavaAsmStruct(jf.vja,JO_goto,label[0]);
				jf.label.insert(pair<string,int>(label[1],jf.vja.size()));
			}
		}

		if(s->exprlist.size()!=s->stmtlist.size()){
			//Ōelse߂ꍇ
			Output_Statement(jf,*(s->stmtlist.end()-1),labelcnt,loop_label,for_label,do_label);
		}
		//IF߂̍Ō
		jf.label.insert(pair<string,int>(label[0],jf.vja.size()));

		break;

	//---------------------------------------------------------			
	case T_LIST:
		for(sit=s->stmtlist.begin();sit!=s->stmtlist.end();sit++)
			Output_Statement(jf,*sit,labelcnt,loop_label,for_label,do_label);
		break;
	//---------------------------------------------------------			
	case T_FOR:
		//ϐ擾
		f=jf.f;
		v=GetVariableFromString(IDlist[s->exprlist[0]->index],f);
		if(v==NULL){
			f=NULL;
			v=GetVariableFromString(IDlist[s->exprlist[0]->index],f);
		}
		if(v==NULL){
			ErrList.push_back("err_subst");
			return;
		}

		//l
		Output_Expression(jf,s->exprlist[1],labelcnt);
		
		if(v->type.type==T_INT)	Output_Variable(jf.vja,v,f,JO_istore);
		else if(v->type.type==T_FLOAT)	Output_Variable(jf.vja,v,f,JO_fstore);
		else{
			ErrList.push_back("err_for_init");
			return;
		}

		//IlĂ
		Output_Expression(jf,s->exprlist[2],labelcnt);
		//܂łŃX^bN > Il
		
		//step̒̕l͍̂ɏĂ
		if(s->exprlist.size()==4){

			//Stepw肪鎞
			Output_Expression(jf,s->exprlist[3],labelcnt);
			// > Il step
			
			//g萔ł͂Ȃꍇ͌iK+-ǂ炩iȂ̂
			//̂Ƃ̕lmۂĂ
			if(s->exprlist[3]->exprtype!=T_CONST){
				sgn=0;
				
				AddJavaAsmStruct(jf.vja,JO_dup_x1);
				// > step Il step
				//gbvstepsigno

				label[0]="for_step_sign_neg."+string(itoa(labelcnt,buf,10));
				label[1]="for_step_sign_eq."+string(itoa(labelcnt,buf,10));
				label[2]="for_step_sign_last."+string(itoa(labelcnt,buf,10));
				labelcnt++;
				if(v->type.type==T_INT){
					//0ȏȂ1AłȂ-1
					AddJavaAsmStruct(jf.vja,JO_dup);
					AddJavaAsmStruct(jf.vja,JO_ifle,label[0]);
					AddJavaAsmStruct(jf.vja,JO_pop);
					AddJavaAsmStruct(jf.vja,JO_iconst_1);
					AddJavaAsmStruct(jf.vja,JO_goto,label[2]);
					jf.label.insert(pair<string,int>(label[0],jf.vja.size()));
					AddJavaAsmStruct(jf.vja,JO_ifeq,label[1]);
					AddJavaAsmStruct(jf.vja,JO_iconst_m1);
					AddJavaAsmStruct(jf.vja,JO_goto,label[2]);
					jf.label.insert(pair<string,int>(label[1],jf.vja.size()));
					AddJavaAsmStruct(jf.vja,JO_iconst_0);
					jf.label.insert(pair<string,int>(label[2],jf.vja.size()));
				}
				else if(v->type.type==T_FLOAT){
					//0ȏȂ1AłȂ-1
					AddJavaAsmStruct(jf.vja,JO_fconst_0);
					AddJavaAsmStruct(jf.vja,JO_fcmpg);
				}
				else{
					ErrList.push_back("err_for");
					return;
				}
				
				//܂ł> step Il sign ƂȂ
				//p炵 > sign Il step sign Il̏ԂɂĂ
				//Q̒lt] > step sign Il
				//dup2_x1ŗz`
				AddJavaAsmStruct(jf.vja,JO_swap);
				AddJavaAsmStruct(jf.vja,JO_dup2_x1);
			}
			else{
				if(v->type.type==T_INT){
					if(s->exprlist[3]->ival<0) sgn=-1;
					else sgn=1;
				}
				else if(v->type.type==T_FLOAT){
					if(s->exprlist[3]->ival<0) sgn=-1;
					else sgn=1;
				}
				else{
					ErrList.push_back("err_for");
					return;
				}
				//constȂIl step̂
				//dup2pop > Il step IlɂĂ
				AddJavaAsmStruct(jf.vja,JO_dup2);
				AddJavaAsmStruct(jf.vja,JO_pop);
			}
		}
		else{
			//Ȃꍇ11.0ς
			if(v->type.type==T_INT)	AddJavaAsmStruct(jf.vja,JO_iconst_1);
			else AddJavaAsmStruct(jf.vja,JO_fconst_1);
			sgn=1;
			//constȂ̂ŏIl step
			//constȂIl step̂
			//dup2pop > Il step IlɂĂ
			AddJavaAsmStruct(jf.vja,JO_dup2);
			AddJavaAsmStruct(jf.vja,JO_pop);
		}

		//Ōɔrpɒl[h
		if(v->type.type==T_INT)	Output_Variable(jf.vja,v,f,JO_iload);
		else Output_Variable(jf.vja,v,f,JO_fload);

		label[0]="for_first."+string(itoa(labelcnt,buf,10));
		label[1]="for_loop."+string(itoa(labelcnt,buf,10));
		label[2]="for_last."+string(itoa(labelcnt,buf,10));
		labelcnt++;

		//ŏ̔
		//constłȂ> sign Il step sign Il lKv

		AddJavaAsmStruct(jf.vja,JO_goto,label[0]);


		//[vɔł
		jf.label.insert(pair<string,int>(label[1],jf.vja.size()));

		//[vĂƂ

		//܂ŁA> sign Il step
		//  > Il step (const)
		//ɂ̒lۑ
		if(sgn==0) AddJavaAsmStruct(jf.vja,JO_dup_x2);
		else AddJavaAsmStruct(jf.vja,JO_dup2);

		//ŁA> step sign Il step
		//> Il step Il step (const)

		//Z
		if(v->type.type==T_INT)	Output_Variable(jf.vja,v,f,JO_iload);
		else Output_Variable(jf.vja,v,f,JO_fload);
		
		//Ƃ肠step𑫂
		//constłȂꍇ͂Ƃ̓sł܂load
		//> step sign IlȂ̂> sign Il step sign Il
		
		if(v->type.type==T_INT){
			AddJavaAsmStruct(jf.vja,JO_iadd);
			if(sgn==0){
				Output_Variable(jf.vja,v,f,JO_istore);
				AddJavaAsmStruct(jf.vja,JO_dup2_x1);
				Output_Variable(jf.vja,v,f,JO_iload);
			}
			else{
				AddJavaAsmStruct(jf.vja,JO_dup);
				Output_Variable(jf.vja,v,f,JO_istore);
			}
		}
		else{
			AddJavaAsmStruct(jf.vja,JO_fadd);
			if(sgn==0){
				Output_Variable(jf.vja,v,f,JO_fstore);
				AddJavaAsmStruct(jf.vja,JO_dup2_x1);
				Output_Variable(jf.vja,v,f,JO_fload);
			}
			else{
				AddJavaAsmStruct(jf.vja,JO_dup);
				Output_Variable(jf.vja,v,f,JO_fstore);
			}
		}

		


		//̈ʒu[v̂͂
		jf.label.insert(pair<string,int>(label[0],jf.vja.size()));
		
		//ŁA召r
		//ŁA> sign Il step sign Il l
		//> Il step Il l

		if(v->type.type==T_INT){
			if(sgn==0){
				//ŁA> sign Il step sign Il l
				//signlp
				//܂iKłǂ炪傫߂Ȃ΂ȂȂ
				//肽Ƃ낾I[o[t[̂ł߂ifŁB
				label[3]="for_sign1."+string(itoa(labelcnt,buf,10));
				label[4]="for_sign2."+string(itoa(labelcnt,buf,10));
				label[5]="for_sign_last."+string(itoa(labelcnt,buf,10));
				labelcnt++;
				//Qr̂dup2
				AddJavaAsmStruct(jf.vja,JO_dup2);
				//l > Il̏ꍇ
				AddJavaAsmStruct(jf.vja,JO_if_icmpgt,label[3]);
				//̂Ă
				AddJavaAsmStruct(jf.vja,JO_pop);
				AddJavaAsmStruct(jf.vja,JO_pop);
				AddJavaAsmStruct(jf.vja,JO_iconst_1);
				AddJavaAsmStruct(jf.vja,JO_goto,label[5]);
				jf.label.insert(pair<string,int>(label[3],jf.vja.size()));
				//l < Il̏ꍇ
				AddJavaAsmStruct(jf.vja,JO_if_icmpeq,label[4]);
				AddJavaAsmStruct(jf.vja,JO_iconst_m1);
				AddJavaAsmStruct(jf.vja,JO_goto,label[5]);
				jf.label.insert(pair<string,int>(label[4],jf.vja.size()));
				//vꍇ0
				AddJavaAsmStruct(jf.vja,JO_iconst_0);
				jf.label.insert(pair<string,int>(label[5],jf.vja.size()));

				//ŁA> sign Il step sign l
				AddJavaAsmStruct(jf.vja,JO_imul);
				//> sign Il step lr
				//sign==1AȂ킿l㏸ꍇ͏Il < l̏Ń[vI
				AddJavaAsmStruct(jf.vja,JO_ifgt,label[2]);
			}
			else{
				//萔Ȃ̂Ŋɒl킩ĂāAsignlpȂ
				//sign==1Ȃ l > Il ŏI
				if(sgn==1) AddJavaAsmStruct(jf.vja,JO_if_icmplt,label[2]);
				else AddJavaAsmStruct(jf.vja,JO_if_icmpgt,label[2]);
				// > Il step Ŏ̃[v
			}
		}
		else{
			AddJavaAsmStruct(jf.vja,JO_fcmpg);
			if(sgn==0){
				//Ƃ肠r̂ŁAsign̒lƂɂĔ]
				//>sign Il step sign rʂ̌`
				AddJavaAsmStruct(jf.vja,JO_imul);
				//> sign Il step lr
				//sign==1AȂ킿l㏸ꍇ͏Il < l̏Ń[vI
				AddJavaAsmStruct(jf.vja,JO_iflt,label[2]);
			}
			else{
				//l萔Ŋɔr\
				//fcmpgŏIl < lȂ-1Ă邽߁AȂI
				if(sgn==1) AddJavaAsmStruct(jf.vja,JO_ifgt,label[2]);
				else AddJavaAsmStruct(jf.vja,JO_iflt,label[2]);
				// > Il step Ŏ̃[v
			}
		}

		//ȅ
		for_label.push_back(label[2]);
		loop_label.push_back(label[1]);
		for(sit=s->stmtlist.begin();sit!=s->stmtlist.end();sit++)
			Output_Statement(jf,*sit,labelcnt,loop_label,for_label,do_label);

		//Zɂǂ
		AddJavaAsmStruct(jf.vja,JO_goto,label[1]);
		//[v
		jf.label.insert(pair<string,int>(label[2],jf.vja.size()));

		//X^bN̒gĂ
		//> sign Il (step)
		AddJavaAsmStruct(jf.vja,JO_pop);
		AddJavaAsmStruct(jf.vja,JO_pop);
		if(sgn==0) AddJavaAsmStruct(jf.vja,JO_pop);

		for_label.pop_back();
		loop_label.pop_back();
		break;

	//---------------------------------------------------------			
	case T_DO:

		//[v̊JnʒuƏIʒũx
		label[0]="do_first."+string(itoa(labelcnt,buf,10));
		label[1]="do_last."+string(itoa(labelcnt,buf,10));
		labelcnt++;

		//ŏwhile
		e=s->exprlist[0];
		jf.label.insert(pair<string,int>(label[0],jf.vja.size()));
		
		//while̒gΔ
		if(!(e->exprtype==T_CONST && e->index==T_WHILE && e->type==T_INT && e->ival==1)){
			if(e->exprtype==T_OP2 && e->type>=T_EQ && e->type<=T_GE){
				//ȗłꍇ
				Output_Expression(jf,e->elist[0],labelcnt);
				Output_Expression(jf,e->elist[1],labelcnt);
				if(e->index==T_WHILE) Output_Branch(jf.vja,e->elist[0]->etype.type,e->type,false,label[1]);
				else Output_Branch(jf.vja,e->elist[0]->etype.type,e->type,true,label[1]);
			}
			else{
				Output_Expression(jf,e,labelcnt);
				//0ȂWv
				if(e->index==T_WHILE) AddJavaAsmStruct(jf.vja,JO_ifne,label[1]);
				else AddJavaAsmStruct(jf.vja,JO_ifeq,label[1]);
			}
		}
		
		//ȅ
		loop_label.push_back(label[0]);
		do_label.push_back(label[1]);
		for(sit=s->stmtlist.begin();sit!=s->stmtlist.end();sit++)
			Output_Statement(jf,*sit,labelcnt,loop_label,for_label,do_label);

		//Ō̏
		e=s->exprlist[1];
		//while̒gΔ
		if(!(e->exprtype==T_CONST && e->index==T_WHILE && e->type==T_INT && e->ival==1)){
			if(e->exprtype==T_OP2 && e->type>=T_EQ && e->type<=T_GE){
				//ȗłꍇ
				Output_Expression(jf,e->elist[0],labelcnt);
				Output_Expression(jf,e->elist[1],labelcnt);
				if(e->index==T_WHILE) Output_Branch(jf.vja,e->elist[0]->etype.type,e->type,true,label[0]);
				else Output_Branch(jf.vja,e->elist[0]->etype.type,e->type,false,label[0]);
			}
			else{
				Output_Expression(jf,e,labelcnt);
				//0ȂWv
				if(e->index==T_WHILE) AddJavaAsmStruct(jf.vja,JO_ifeq,label[0]);
				else AddJavaAsmStruct(jf.vja,JO_ifne,label[0]);
			}
		}
		else{
			//while̎w肪Ȃ̂ŎIɃWv
			AddJavaAsmStruct(jf.vja,JO_goto,label[0]);
		}

		jf.label.insert(pair<string,int>(label[1],jf.vja.size()));
		break;


	//---------------------------------------------------------			
	default:
		break;
	}
}

//eo^
void Output_Expression(JavaAsmFunction& jf,Expression *e,int &labelcnt){
	Function *f;
	Variable *v;
	ExprVec::iterator eit;
	string st,label[3];
	char buf[256];
	int i,j,oldlabel;

	switch(e->exprtype){
	//---------------------------------------------------------			
	case T_ID:
		//ϐ
		f=jf.f;
		v=GetVariableFromString(IDlist[e->index],f);
		if(v==NULL){
			f=NULL;
			v=GetVariableFromString(IDlist[e->index],f);
		}
		if(v==NULL){
			ErrList.push_back("err_subst");
			return;
		}

		//z񂩕Ȃ烊t@X
		if(v->type.type==T_STRING || v->type.arraydepth.size()) Output_Variable(jf.vja,v,f,JO_aload);
		else if(v->type.type==T_INT)	Output_Variable(jf.vja,v,f,JO_iload);
		else Output_Variable(jf.vja,v,f,JO_fload);

		//zw肪Ȃ炠镶load
		for(i=0;i<e->elist.size();i++){
			Output_Expression(jf,e->elist[i],labelcnt);
			
			//Ōint,floatȂialoadAfaloadg
			//StringAzȂaaload
			if(i==e->elist.size()-1 && v->type.arraydepth.size()==e->elist.size()){
				if(v->type.type==T_INT) AddJavaAsmStruct(jf.vja,JO_iaload);
				else if(v->type.type==T_FLOAT) AddJavaAsmStruct(jf.vja,JO_faload);
				else AddJavaAsmStruct(jf.vja,JO_aaload);
			}
			else AddJavaAsmStruct(jf.vja,JO_aaload);
		}

		break;
	//---------------------------------------------------------			
	case T_CALL:
		//֐擾
		f=GetFunctionFromString(IDlist[e->index]);
		if(f==NULL){
			ErrList.push_back("err_call");
			return;
		}

		//eςōs
		for(eit=e->elist.begin();eit!=e->elist.end();eit++)
			Output_Expression(jf,*eit,labelcnt);
		//֐Ăяo
		i=ConstantPool_Add(gcp,CP_METHOD,f->name);
		AddJavaAsmStruct(jf.vja,JO_invokestatic,f->name,i,0);

		break;
	//---------------------------------------------------------			
	case T_CONST:
		if(e->type==T_INT){
			//TCYƂiconst_nbipushsipushƂȊOg
			if(e->ival>=-1 && e->ival<=5) AddJavaAsmStruct(jf.vja,(JavaOpecode)(e->ival+(int)JO_iconst_0));
			else if(e->ival>=-0x80 && e->ival<=0x7F) AddJavaAsmStruct(jf.vja,JO_bipush,"",e->ival);
			else if(e->ival>=-0x8000 && e->ival<=0x7FFF) AddJavaAsmStruct(jf.vja,JO_sipush,"",e->ival);
			else{
				//Ȃ̓RX^gv[
				i=ConstantPool_Add(gcp,CP_INTEGER,"","",e->ival);
				if(i<0x100) AddJavaAsmStruct(jf.vja,JO_ldc,"",i);
				else AddJavaAsmStruct(jf.vja,JO_ldc_w,"",i);
			}
		}
		else if(e->type==T_FLOAT){
			//܂ɂł邩ǂ𔻒
			if(e->fval==(int)e->fval && e->fval>=-0x8000 && e->fval<=0x7FFF){
				e->ival=(int)e->fval;
				//fconstōςނȂ炻ł܂
				if(e->ival>=0 && e->ival<=2) AddJavaAsmStruct(jf.vja,(JavaOpecode)(e->ival+(int)JO_fconst_0));
				else{
					//ƂintŌĂяoăLXg
					if(e->ival>=-1 && e->ival<=5) AddJavaAsmStruct(jf.vja,(JavaOpecode)(e->ival+(int)JO_iconst_0));
					else if(e->ival>=-0x80 && e->ival<=0x7F) AddJavaAsmStruct(jf.vja,JO_bipush,"",e->ival);
					else AddJavaAsmStruct(jf.vja,JO_sipush,"",e->ival);

					AddJavaAsmStruct(jf.vja,JO_i2f);
				}
			}
			else{
				//RX^gv[
				i=ConstantPool_Add(gcp,CP_FLOAT,"","",0,e->fval);
				if(i<0x100) AddJavaAsmStruct(jf.vja,JO_ldc,"",i);
				else AddJavaAsmStruct(jf.vja,JO_ldc_w,"",i);
			}
		}
		else if(e->type==T_STRING){
			//RX^gv[
			i=ConstantPool_Add(gcp,CP_STRING,Strlist[e->index]);
			if(i<0x100) AddJavaAsmStruct(jf.vja,JO_ldc,Strlist[e->index],i);
			else AddJavaAsmStruct(jf.vja,JO_ldc_w,Strlist[e->index],i);
		}
		break;

	//---------------------------------------------------------			
	case T_OP2:
		//&&||^^ʈ
		switch(e->type){
		case T_BOOLOR:
			label[0]="boolor_0."+string(itoa(labelcnt,buf,10));
			label[1]="boolor_1."+string(itoa(labelcnt,buf,10));
			labelcnt++;

			Output_Expression(jf,e->elist[0],labelcnt);
			//̎_0ȊOȂ1ɂďI
			AddJavaAsmStruct(jf.vja,JO_ifeq,label[0]);
			AddJavaAsmStruct(jf.vja,JO_iconst_1);
			AddJavaAsmStruct(jf.vja,JO_goto,label[1]);
			jf.label.insert(pair<string,int>(label[0],jf.vja.size()));

			//Q̔r
			Output_Expression(jf,e->elist[0],labelcnt);
			//ꉞ邱Ƃ0̂Ƃ0̂܂܂ނƂɂ
			AddJavaAsmStruct(jf.vja,JO_dup);
			AddJavaAsmStruct(jf.vja,JO_ifeq,label[1]);
			//0ȊOȂ̂1ς
			AddJavaAsmStruct(jf.vja,JO_pop);
			AddJavaAsmStruct(jf.vja,JO_iconst_1);
			jf.label.insert(pair<string,int>(label[1],jf.vja.size()));

			break;

		case T_BOOLAND:
			label[0]="booland."+string(itoa(labelcnt,buf,10));
			labelcnt++;

			Output_Expression(jf,e->elist[0],labelcnt);
			//̎_0Ȃ炻̂܂܏I
			//0g悤dup
			AddJavaAsmStruct(jf.vja,JO_dup);
			AddJavaAsmStruct(jf.vja,JO_ifeq,label[0]);
			AddJavaAsmStruct(jf.vja,JO_pop);

			//Q
			Output_Expression(jf,e->elist[1],labelcnt);
			//0Ȃ炻̂܂܂ł悢A0ȊOȂ1ɂ
			AddJavaAsmStruct(jf.vja,JO_dup);
			AddJavaAsmStruct(jf.vja,JO_ifeq,label[0]);
			AddJavaAsmStruct(jf.vja,JO_pop);
			AddJavaAsmStruct(jf.vja,JO_iconst_1);
			jf.label.insert(pair<string,int>(label[0],jf.vja.size()));

			break;
		case T_BOOLXOR:
			label[0]="boolxor_0."+string(itoa(labelcnt,buf,10));
			label[1]="boolxor_1."+string(itoa(labelcnt,buf,10));
			labelcnt++;
			
			//e01ɗƂ
			for(i=0;i<2;i++){
				Output_Expression(jf,e->elist[i],labelcnt);
				//̎_0ȊOȂ1ɂ
				AddJavaAsmStruct(jf.vja,JO_dup);
				AddJavaAsmStruct(jf.vja,JO_ifeq,label[i]);
				AddJavaAsmStruct(jf.vja,JO_pop);
				AddJavaAsmStruct(jf.vja,JO_iconst_1);
				jf.label.insert(pair<string,int>(label[i],jf.vja.size()));
			}
			//Ō01Ȃ̂xor
			AddJavaAsmStruct(jf.vja,JO_ixor);
			break;
		case T_PLUS:

			//intfloat͊ȒP
			if(e->etype.type==T_INT){
				Output_Expression(jf,e->elist[0],labelcnt);
				Output_Expression(jf,e->elist[1],labelcnt);
				AddJavaAsmStruct(jf.vja,JO_iadd);
			}
			else if(e->etype.type==T_FLOAT){
				Output_Expression(jf,e->elist[0],labelcnt);
				Output_Expression(jf,e->elist[1],labelcnt);
				AddJavaAsmStruct(jf.vja,JO_fadd);
			}
			else if(e->etype.type==T_STRING){
				
				//StringBufferp
				i=ConstantPool_Add(gcp,CP_CLASS,"java/lang/StringBuffer");
				AddJavaAsmStruct(jf.vja,JO_new,"",i);
				//Ẑ߂dup
				AddJavaAsmStruct(jf.vja,JO_dup);
				//Pڂ̒l
				Output_Expression(jf,e->elist[0],labelcnt);
				//<init>
				i=ConstantPool_Add(gcp,CP_METHOD,"<init>","java/lang/StringBuffer",0,0,"(Ljava/lang/String;)V");
				AddJavaAsmStruct(jf.vja,JO_invokespecial,"StringBuffer.<init>",i);
				//Qڂ̒l
				Output_Expression(jf,e->elist[1],labelcnt);
				//append
				if(e->elist[1]->etype.type==T_INT) i=ConstantPool_Add(gcp,CP_METHOD,"append","java/lang/StringBuffer",0,0,"(I)Ljava/lang/StringBuffer;");
				else if(e->elist[1]->etype.type==T_FLOAT) i=ConstantPool_Add(gcp,CP_METHOD,"append","java/lang/StringBuffer",0,0,"(F)Ljava/lang/StringBuffer;");
				else i=ConstantPool_Add(gcp,CP_METHOD,"append","java/lang/StringBuffer",0,0,"(Ljava/lang/String;)Ljava/lang/StringBuffer;");
				AddJavaAsmStruct(jf.vja,JO_invokevirtual,"StringBuffer.append",i);
				//Stringɖ߂
				i=ConstantPool_Add(gcp,CP_METHOD,"toString","java/lang/StringBuffer",0,0,"()Ljava/lang/String;");
				AddJavaAsmStruct(jf.vja,JO_invokevirtual,"StringBuffer.toString",i);
			}


			break;
		//rZq
		case T_EQ:
		case T_NE:
		case T_LT:
		case T_LE:
		case T_GT:
		case T_GE:
			//Ƃ肠Qlς
			oldlabel=labelcnt++;
			Output_Expression(jf,e->elist[0],labelcnt);
			Output_Expression(jf,e->elist[1],labelcnt);

			//int̏ꍇ
			if(e->elist[0]->etype.type==T_INT){
				switch(e->type){
				case T_EQ:
					label[0]="eq_int_0."+string(itoa(oldlabel,buf,10));
					label[1]="eq_int_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_if_icmpeq,label[0]);
					break;
				case T_NE:
					label[0]="ne_int_0."+string(itoa(oldlabel,buf,10));
					label[1]="ne_int_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_if_icmpne,label[0]);
					break;
				case T_LT:
					label[0]="lt_int_0."+string(itoa(oldlabel,buf,10));
					label[1]="lt_int_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_if_icmplt,label[0]);
					break;
				case T_LE:
					label[0]="le_int_0."+string(itoa(oldlabel,buf,10));
					label[1]="le_int_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_if_icmple,label[0]);
					break;
				case T_GT:
					label[0]="gt_int_0."+string(itoa(oldlabel,buf,10));
					label[1]="gt_int_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_if_icmpgt,label[0]);
					break;
				case T_GE:
					label[0]="ge_int_0."+string(itoa(oldlabel,buf,10));
					label[1]="ge_int_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_if_icmpge,label[0]);
					break;
				}

				AddJavaAsmStruct(jf.vja,JO_iconst_0);
				AddJavaAsmStruct(jf.vja,JO_goto,label[1]);
				jf.label.insert(pair<string,int>(label[0],jf.vja.size()));
				AddJavaAsmStruct(jf.vja,JO_iconst_1);
				jf.label.insert(pair<string,int>(label[1],jf.vja.size()));
			}
			else if(e->elist[0]->etype.type==T_FLOAT){
				//Ƃ肠r
				AddJavaAsmStruct(jf.vja,JO_fcmpl);

				switch(e->type){
				case T_EQ:
					label[0]="eq_float_0."+string(itoa(oldlabel,buf,10));
					label[1]="eq_float_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_ifeq,label[0]);
					break;
				case T_NE:
					label[0]="ne_float_0."+string(itoa(oldlabel,buf,10));
					label[1]="ne_float_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_ifne,label[0]);
					break;
				case T_LT:
					label[0]="lt_float_0."+string(itoa(oldlabel,buf,10));
					label[1]="lt_float_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_iflt,label[0]);
					break;
				case T_LE:
					label[0]="ge_float_0."+string(itoa(oldlabel,buf,10));
					label[1]="ge_float_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_ifle,label[0]);
					break;
				case T_GT:
					label[0]="ge_float_0."+string(itoa(oldlabel,buf,10));
					label[1]="ge_float_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_ifgt,label[0]);
					break;
				case T_GE:
					label[0]="ge_float_0."+string(itoa(oldlabel,buf,10));
					label[1]="ge_float_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_ifge,label[0]);
					break;
				}

				AddJavaAsmStruct(jf.vja,JO_iconst_0);
				AddJavaAsmStruct(jf.vja,JO_goto,label[1]);
				jf.label.insert(pair<string,int>(label[0],jf.vja.size()));
				AddJavaAsmStruct(jf.vja,JO_iconst_1);
				jf.label.insert(pair<string,int>(label[1],jf.vja.size()));
			}
			else if(e->elist[0]->etype.type==T_STRING){
				j=ConstantPool_Add(gcp,CP_METHOD,"compareTo","java/lang/String",0,0,"(Ljava/lang/String;)I");
				//Ƃ肠r
				AddJavaAsmStruct(jf.vja,JO_invokevirtual,"compareTo",j);
				switch(e->type){
				case T_EQ:
					label[0]="eq_string_0."+string(itoa(oldlabel,buf,10));
					label[1]="eq_string_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_ifeq,label[0]);
					break;
				case T_NE:
					label[0]="ne_string_0."+string(itoa(oldlabel,buf,10));
					label[1]="ne_string_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_ifne,label[0]);
					break;
				case T_LT:
					label[0]="lt_string_0."+string(itoa(oldlabel,buf,10));
					label[1]="lt_string_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_iflt,label[0]);
					break;
				case T_LE:
					label[0]="ge_string_0."+string(itoa(oldlabel,buf,10));
					label[1]="ge_string_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_ifle,label[0]);
					break;
				case T_GT:
					label[0]="ge_string_0."+string(itoa(oldlabel,buf,10));
					label[1]="ge_string_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_ifgt,label[0]);
					break;
				case T_GE:
					label[0]="ge_string_0."+string(itoa(oldlabel,buf,10));
					label[1]="ge_string_1."+string(itoa(oldlabel,buf,10));
					AddJavaAsmStruct(jf.vja,JO_ifge,label[0]);
					break;
				}

				AddJavaAsmStruct(jf.vja,JO_iconst_0);
				AddJavaAsmStruct(jf.vja,JO_goto,label[1]);
				jf.label.insert(pair<string,int>(label[0],jf.vja.size()));
				AddJavaAsmStruct(jf.vja,JO_iconst_1);
				jf.label.insert(pair<string,int>(label[1],jf.vja.size()));
			}
			break;

		//-------------------------
		//l݂̂ΏۂƂ
		case T_MINUS:
			Output_Expression(jf,e->elist[0],labelcnt);
			Output_Expression(jf,e->elist[1],labelcnt);
			if(e->etype.type==T_INT) AddJavaAsmStruct(jf.vja,JO_isub);
			else AddJavaAsmStruct(jf.vja,JO_fsub);
			break;

		case T_MULT:
			Output_Expression(jf,e->elist[0],labelcnt);
			Output_Expression(jf,e->elist[1],labelcnt);
			if(e->etype.type==T_INT) AddJavaAsmStruct(jf.vja,JO_imul);
			else AddJavaAsmStruct(jf.vja,JO_fmul);
			break;
		
		case T_DIV:
			Output_Expression(jf,e->elist[0],labelcnt);
			Output_Expression(jf,e->elist[1],labelcnt);
			if(e->etype.type==T_INT) AddJavaAsmStruct(jf.vja,JO_idiv);
			else AddJavaAsmStruct(jf.vja,JO_fdiv);
			break;
		
		case T_MOD:
			Output_Expression(jf,e->elist[0],labelcnt);
			Output_Expression(jf,e->elist[1],labelcnt);
			if(e->etype.type==T_INT) AddJavaAsmStruct(jf.vja,JO_irem);
			else AddJavaAsmStruct(jf.vja,JO_frem);
			break;

		//-------------------------
		//int݂̂ΏۂƂ
		case T_LSHIFT:
			Output_Expression(jf,e->elist[0],labelcnt);
			Output_Expression(jf,e->elist[1],labelcnt);
			AddJavaAsmStruct(jf.vja,JO_ishl);
			break;

		case T_RSHIFT:
			Output_Expression(jf,e->elist[0],labelcnt);
			Output_Expression(jf,e->elist[1],labelcnt);
			AddJavaAsmStruct(jf.vja,JO_iushr);
			break;
		case T_BITOR:
			Output_Expression(jf,e->elist[0],labelcnt);
			Output_Expression(jf,e->elist[1],labelcnt);
			AddJavaAsmStruct(jf.vja,JO_ior);
			break;
		case T_BITAND:
			Output_Expression(jf,e->elist[0],labelcnt);
			Output_Expression(jf,e->elist[1],labelcnt);
			AddJavaAsmStruct(jf.vja,JO_iand);
			break;
		case T_BITXOR:
			Output_Expression(jf,e->elist[0],labelcnt);
			Output_Expression(jf,e->elist[1],labelcnt);
			AddJavaAsmStruct(jf.vja,JO_ixor);
			break;
		}
		break;

			



	//---------------------------------------------------------			
	case T_OP1:

		//܂go
		Output_Expression(jf,e->elist[0],labelcnt);

		switch(e->type){
		case T_NEG:
			//P}CiX
			if(e->etype.type==T_INT) AddJavaAsmStruct(jf.vja,JO_ineg);
			else AddJavaAsmStruct(jf.vja,JO_fneg);
			break;

		case T_BITNOT:
			//rbgPʂ̔]
			//ڃT|[gĂȂ̂ŁAxorőΉ
			AddJavaAsmStruct(jf.vja,JO_bipush,"",-1);
			AddJavaAsmStruct(jf.vja,JO_ixor);
			break;

		case T_BOOLNOT:
			//0Ȃ1ցA0ȊOȂ0
			label[0]="boolnot_0."+string(itoa(labelcnt,buf,10));
			label[1]="boolnot_1."+string(itoa(labelcnt,buf,10));
			labelcnt++;

			AddJavaAsmStruct(jf.vja,JO_ifeq,label[0]);
			//0ȊOȂ̂0ɂ
			AddJavaAsmStruct(jf.vja,JO_iconst_1);
			AddJavaAsmStruct(jf.vja,JO_goto,label[1]);
			//0ɂ
			jf.label.insert(pair<string,int>(label[0],jf.vja.size()));
			AddJavaAsmStruct(jf.vja,JO_iconst_0);
			jf.label.insert(pair<string,int>(label[1],jf.vja.size()));
			break;
	
		default:
			break;
		}
		break;

	//---------------------------------------------------------			
	case T_TYPE:


		Output_Expression(jf,e->elist[0],labelcnt);
		if(e->type==e->elist[0]->etype.type && e->elist[0]->etype.arraydepth.size()==0){
			//go͂
		}
		else if(e->elist[0]->etype.arraydepth.size()>0 && e->etype.type==T_INT){
			//z̒
			AddJavaAsmStruct(jf.vja,JO_arraylength);
		}
		else if(e->elist[0]->etype.type==T_INT){
			//intfloat,string
			
			if(e->type==T_FLOAT){
				AddJavaAsmStruct(jf.vja,JO_i2f);
			}
			else if(e->type==T_STRING){
				i=ConstantPool_Add(gcp,CP_METHOD,"valueOf","java/lang/String",0,0,"(I)Ljava/lang/String;");
				AddJavaAsmStruct(jf.vja,JO_invokestatic,"StringBuffer.valueOf",i);
			}
			else ErrList.push_back("err_cast-int_to"+string(itoa(e->lineno,buf,10)));
		}
		else if(e->elist[0]->etype.type==T_FLOAT){
			//floatint,string
			if(e->type==T_INT){
				AddJavaAsmStruct(jf.vja,JO_f2i);
			}
			else if(e->type==T_STRING){
				i=ConstantPool_Add(gcp,CP_METHOD,"valueOf","java/lang/String",0,0,"(F)Ljava/lang/String;");
				AddJavaAsmStruct(jf.vja,JO_invokestatic,"StringBuffer.valueOf",i);
			}
			else ErrList.push_back("err_cast-float_to"+string(itoa(e->lineno,buf,10)));
		}
		else if(e->elist[0]->etype.type==T_STRING){
			//OKvȂ̂ŁARTClassg
			if(e->type==T_INT){
				i=ConstantPool_Add(gcp,CP_METHOD,"_String_to_int","RTClass",0,0,"(Ljava/lang/String;)I");
				AddJavaAsmStruct(jf.vja,JO_invokestatic,"RTClass._String_to_int",i);
			}
			else if(e->type==T_FLOAT){
				i=ConstantPool_Add(gcp,CP_METHOD,"_String_to_float","RTClass",0,0,"(Ljava/lang/String;)F");
				AddJavaAsmStruct(jf.vja,JO_invokestatic,"RTClass._String_to_float",i);
			}
			else ErrList.push_back("err_cast-string_to"+string(itoa(e->lineno,buf,10)));
		}
		else{
			ErrList.push_back("err_cast-oops?_"+string(itoa(e->lineno,buf,10)));
		}




		break;
	//---------------------------------------------------------			
	default:
		break;
	}

}

//BOOLl킴킴߂܂łȂꍇ̕
void Output_Branch(VJA &vja,int type,int cmp,bool b_ift,string label){
	int j;

	if(type==T_FLOAT || type==T_STRING){
		//Ƃ肠cmp
		if(type==T_FLOAT) AddJavaAsmStruct(vja,JO_fcmpg);
		else{
			j=ConstantPool_Add(gcp,CP_METHOD,"compareTo","java/lang/String",0,0,"(Ljava/lang/String;)I");
			AddJavaAsmStruct(vja,JO_invokevirtual,"compareTo",j);
		}
		//-1 0 1Ōʂ킩Ă
		switch(cmp){
		case T_EQ:
			if(b_ift) AddJavaAsmStruct(vja,JO_ifeq,label);
			else AddJavaAsmStruct(vja,JO_ifne,label);
			break;
		case T_NE:
			if(b_ift) AddJavaAsmStruct(vja,JO_ifne,label);
			else AddJavaAsmStruct(vja,JO_ifeq,label);
			break;
		case T_LE:
			if(b_ift) AddJavaAsmStruct(vja,JO_ifle,label);
			else AddJavaAsmStruct(vja,JO_ifgt,label);
			break;
		case T_LT:
			if(b_ift) AddJavaAsmStruct(vja,JO_iflt,label);
			else AddJavaAsmStruct(vja,JO_ifge,label);
			break;
		case T_GE:
			if(b_ift) AddJavaAsmStruct(vja,JO_ifge,label);
			else AddJavaAsmStruct(vja,JO_iflt,label);
			break;
		case T_GT:
			if(b_ift) AddJavaAsmStruct(vja,JO_ifgt,label);
			else AddJavaAsmStruct(vja,JO_ifle,label);
			break;
		}
	}
	else if(type==T_INT){
		switch(cmp){
		case T_EQ:
			if(b_ift) AddJavaAsmStruct(vja,JO_if_icmpeq,label);
			else AddJavaAsmStruct(vja,JO_if_icmpne,label);
			break;
		case T_NE:
			if(b_ift) AddJavaAsmStruct(vja,JO_if_icmpne,label);
			else AddJavaAsmStruct(vja,JO_if_icmpeq,label);
			break;
		case T_LE:
			if(b_ift) AddJavaAsmStruct(vja,JO_if_icmple,label);
			else AddJavaAsmStruct(vja,JO_if_icmpgt,label);
			break;
		case T_LT:
			if(b_ift) AddJavaAsmStruct(vja,JO_if_icmplt,label);
			else AddJavaAsmStruct(vja,JO_if_icmpge,label);
			break;
		case T_GE:
			if(b_ift) AddJavaAsmStruct(vja,JO_if_icmpge,label);
			else AddJavaAsmStruct(vja,JO_if_icmplt,label);
			break;
		case T_GT:
			if(b_ift) AddJavaAsmStruct(vja,JO_if_icmpgt,label);
			else AddJavaAsmStruct(vja,JO_if_icmplt,label);
			break;
		}
	}



}


//ϐɑ
void Output_Variable(VJA &vja,Variable *v,Function *f,JavaOpecode baseop){
	int i;
	int op;
	const int opsize=6;
	JavaOpecode jo[opsize][3]={
		{JO_astore,JO_astore_0,JO_putstatic},
		{JO_istore,JO_istore_0,JO_putstatic},
		{JO_fstore,JO_fstore_0,JO_putstatic},
		{JO_aload,JO_aload_0,JO_getstatic},
		{JO_iload,JO_iload_0,JO_getstatic},
		{JO_fload,JO_fload_0,JO_getstatic},
	};

	for(op=0;op<opsize;op++) if(jo[op][0]==baseop) break;
	if(op==opsize){
		ErrList.push_back("err_output_variable");
		return;
	}

	if(f){
		//[Jϐ
		//ID擾
		i=GetVariableIDFromString(v->name,f);
		if(i<4) AddJavaAsmStruct(vja,(JavaOpecode)(i+(int)jo[op][1]),v->name);
		else if(i<0x100) AddJavaAsmStruct(vja,jo[op][0],v->name,i);
		else AddJavaAsmStruct(vja,JO_wide,v->name,i,jo[op][0]);
	}
	else{
		//O[oϐ
		i=ConstantPool_Add(gcp,CP_FIELD,v->name);
		AddJavaAsmStruct(vja,jo[op][2],v->name,i,0);
	}
}



//z𐶐
void Output_CreateInitArray(VJA &vja,Variable *v){
	int i,j,dim;
	string s;

	if(v->type.arraydepth.size()==0){
		//͂Ȃ
		ErrList.push_back("err");
		return;
	}
	
	for(i=0;i<v->type.arraydepth.size();i++){
		dim=v->type.arraydepth[i];
		s+="[";

		//TCYɂĕς
		if(dim<=5) AddJavaAsmStruct(vja,(JavaOpecode)(dim+(int)JO_iconst_0),"",0,0);
		else if(dim<0x80) AddJavaAsmStruct(vja,JO_bipush,"",dim,0);
		else if(dim<0x8000) AddJavaAsmStruct(vja,JO_sipush,"",dim,0);
		else{
			//QoCg傫Ȑ̓RX^gv[gȂ
			j=ConstantPool_Add(gcp,CP_INTEGER,"","",dim,0);
			//1byteȂldcA2byteȂldc_w
			if(j<0x100)	AddJavaAsmStruct(vja,JO_ldc,"",j,0);
			else AddJavaAsmStruct(vja,JO_ldc,"",j,0);
		}
	}

	if(v->type.arraydepth.size()==1){
		//1z
		if(v->type.type==T_INT) AddJavaAsmStruct(vja,JO_newarray,"",10,0);
		else if(v->type.type==T_FLOAT) AddJavaAsmStruct(vja,JO_newarray,"",6,0);
		else if(v->type.type==T_STRING){
			//NXw
			j=ConstantPool_Add(gcp,CP_CLASS,"java/lang/String","",0,0);
			AddJavaAsmStruct(vja,JO_anewarray,"",j,0);
		}
		else{
			ErrList.push_back("err");
			return;
		}

	}
	else{
		//2ȏ̏ꍇ
		if(v->type.type==T_INT) s+="I";
		else if(v->type.type==T_FLOAT) s+="F";
		else if(v->type.type==T_STRING) s+="Ljava/lang/String;";
		else{
			ErrList.push_back("err");
			return;
		}
		//NXw
		j=ConstantPool_Add(gcp,CP_CLASS,s,"",0,0);
		AddJavaAsmStruct(vja,JO_multianewarray,"",j,v->type.arraydepth.size());
	}

}

//Stringς
void Output_CreateInitString(VJA &vja){
	int i;

	i=ConstantPool_Add(gcp,CP_STRING,"","",0,0);

	//ʂɂi𗘗p
	//1byteȂldcA2byteȂldc_w
	if(i<0x100)	AddJavaAsmStruct(vja,JO_ldc,"",i,0);
	else AddJavaAsmStruct(vja,JO_ldc,"",i,0);
	return;

}

void AddJavaAsmStruct(VJA &vja,JavaOpecode op,string ops,int opi1,int opi2){
	JavaAsmStruct jas;

	if(vja.size()==0)	jas.offset=0;
	else jas.offset=vja[vja.size()-1].offset+vja[vja.size()-1].size;
	jas.op=op;
	jas.ops=ops;
	jas.opi[0]=opi1;
	jas.opi[1]=opi2;
	jas.size=JOpSize[op];
	vja.push_back(jas);
	return;
}


void Output_ArrangeOpecode(JavaAsmFunction& jaf){
	//IyR[hoCgR[hɕύX
	int i;
	VJA::iterator vit;


	for(vit=jaf.vja.begin();vit!=jaf.vja.end();vit++){
		
		//1byte̖߂Ȃ炱ꂾOK
		vit->buf[0]=vit->op;

		//ߕʂɕ
		switch(vit->op){
		//Ƃ1byte
		case JO_aload:
		case JO_astore:
		case JO_bipush:
		case JO_fload:
		case JO_fstore:
		case JO_iload:
		case JO_istore:
		case JO_ldc:
		case JO_newarray:
			vit->buf[1]=(vit->opi[0] & 0xff);
			break;

			//Ƃshort𕪉̂
		case JO_anewarray:
		case JO_getstatic:
		case JO_invokespecial:
		case JO_invokestatic:
		case JO_invokevirtual:
		case JO_ldc_w:
		case JO_new:
		case JO_putfield:
		case JO_putstatic:
		case JO_sipush:
			vit->buf[1]=(vit->opi[0] & 0xff00)>>8;
			vit->buf[2]=(vit->opi[0] & 0xff);
			break;

			//ѐ惉x
		case JO_goto:
		case JO_if_icmpeq:
		case JO_if_icmpne:
		case JO_if_icmplt:
		case JO_if_icmpge:
		case JO_if_icmpgt:
		case JO_if_icmple:
		case JO_ifeq:
		case JO_ifne:
		case JO_iflt:
		case JO_ifge:
		case JO_ifgt:
		case JO_ifle:
			{
				map<string,int>::iterator mit=jaf.label.find(vit->ops);
				if(mit==jaf.label.end()){
					ErrList.push_back("err_label_alloc");
					return;
				}
				i=jaf.vja[mit->second].offset-vit->offset;
				vit->buf[1]=(i & 0xff00)>>8;
				vit->buf[2]=(i & 0xff);
				
			}
			break;

		//̑
		case JO_multianewarray:
			vit->buf[1]=(vit->opi[0] & 0xff00)>>8;
			vit->buf[2]=(vit->opi[0] & 0xff);
			vit->buf[3]=(vit->opi[1] & 0xff);
			break;
		case JO_wide:
			vit->buf[1]=(vit->opi[1] & 0xff);
			vit->buf[2]=(vit->opi[0] & 0xff00)>>8;
			vit->buf[3]=(vit->opi[0] & 0xff);
			break;
		default:
			break;
		}

		for(i=0;i<vit->size;i++) jaf.buf.push_back(vit->buf[i]);
	}
	
	if(jaf.vja.size()) jaf.size=(jaf.vja.end()-1)->offset+(jaf.vja.end()-1)->size;
	else jaf.size=0;


}


void Output_ClassFile(){
	FILE *f;
	string fn;
	int i;
	short s,sbuf[256];
	
	fn=MyClassName + ".class";
	ofs << endl << endl << endl;
	ofs << "------------------------------------" << endl;
	ofs << "Output " << fn << endl;
	ofs << "------------------------------------" << endl;
	f=fopen(fn.c_str(),"wb");
	if(f==NULL){
		ofs <<" nnn"<<endl;
		return;
	}

	//MAGIC(CAFEBABE)
	i=ChangeBO((int)0xCAFEBABE);
	fwrite(&i,4,1,f);

	//o[W(Java1.4.2ɂ킹
	sbuf[0]=ChangeBO((short)0);
	sbuf[1]=ChangeBO((short)46);
	fwrite(sbuf,4,1,f);
	
	

	//--------------------------------------------
	//RX^gv[
	s=ChangeBO((short)gcp.size());
	fwrite(&s,2,1,f);
	for(i=1;i<gcp.size();i++)	Output_ConstantPool(f,gcp[i]);

	//access_flag,this_class,super_class,interface_count
	//public=0x01Afinal=0x10Asuper=0x20
	sbuf[0]=ChangeBO((short)0x33);
	i=ConstantPool_Add(gcp,CP_CLASS,MyClassName);
	sbuf[1]=ChangeBO((short)i);
	i=ConstantPool_Add(gcp,CP_CLASS,"java/lang/Object");
	sbuf[2]=ChangeBO((short)i);
	//C^[tF[X͎Ȃ
	sbuf[3]=0;
	fwrite(sbuf,sizeof(short)*4,1,f);

	//C^[tF[X͎Ȃ̂łǂł悢

	//tB[h
	s=ChangeBO((short)gVarlist->size());
	fwrite(&s,sizeof(short),1,f);

	for(Varlist::iterator vit=gVarlist->begin();vit!=gVarlist->end();vit++){
		//access_flag  public=0x1 static=0x8
		sbuf[0]=ChangeBO((short)0x9);
		//name
		sbuf[1]=ChangeBO((short)ConstantPool_Add(gcp,CP_UTF8,(*vit)->name));
		//type
		sbuf[2]=ChangeBO((short)ConstantPool_Add(gcp,CP_UTF8,CreateJavaTypeString(&(*vit)->type)));
		//num_attrib
		sbuf[3]=0;
		fwrite(sbuf,sizeof(short)*4,1,f);
	}
	
	//\bh
	s=ChangeBO((short)(gJFunc.size()));
	fwrite(&s,sizeof(short),1,f);
	
	ofs << endl << "----------------------------------------" << endl;
	for(JFuncVec::iterator jit=gJFunc.begin();jit!=gJFunc.end();jit++){
		ofs << "[output " << (*jit)->name << "  fseek 0x" << hex << ftell(f) << dec << "]" << endl;
		//access_flag public=0x1 static=0x8
		//<init>publiĉ݁A<cinit>statiĉ
		if((*jit)->name=="<init>") sbuf[0]=ChangeBO((short)0x1);
		else if((*jit)->name=="<cinit>") sbuf[0]=ChangeBO((short)0x8);
		else sbuf[0]=ChangeBO((short)0x9);
		//name
		sbuf[1]=ChangeBO((short)ConstantPool_Add(gcp,CP_UTF8,(*jit)->name));
		//type
		if((*jit)->f==NULL) sbuf[2]=ChangeBO((short)ConstantPool_Add(gcp,CP_UTF8,"()V"));
		else sbuf[2]=ChangeBO((short)ConstantPool_Add(gcp,CP_UTF8,CreateJavaTypeString((*jit)->f)));
		//num_attrib
		sbuf[3]=ChangeBO((short)1);
		fwrite(sbuf,sizeof(short)*4,1,f);

		//CodeAgr[g
		sbuf[0]=ChangeBO((short)ConstantPool_Add(gcp,CP_UTF8,"Code"));
		fwrite(sbuf,sizeof(short),1,f);

		Output_ArrangeOpecode(**jit);

		//Agr[g̒
		//sΉ̃e[uĂ邩ȂňقȂ
		if((*jit)->la.empty()) i=ChangeBO((int)(2+2+4+(*jit)->size+2+2));
		else i=ChangeBO((int)(2+2+4+(*jit)->size+2+2+(2+4+2+(*jit)->la.size()*4)));
		fwrite(&i,sizeof(int),1,f);
		//max_stack,max_locals
		sbuf[0]=ChangeBO((short)0xff);
		if((*jit)->name=="<init>") sbuf[1]=ChangeBO((short)1);
		else if((*jit)->name=="<init>") sbuf[1]=ChangeBO((short)0);
		else sbuf[1]=ChangeBO((short)((*jit)->f->args.size()+(*jit)->f->vl.size()));
		fwrite(sbuf,sizeof(short)*2,1,f);

		//R[h̒
		i=ChangeBO((*jit)->size);
		fwrite(&i,sizeof(int),1,f);
		
		//R[h{
		ofs << "\t[code - 0x" << hex << ftell(f) << dec << "]" << endl;

		fwrite((char*)(&*(*jit)->buf.begin()),(*jit)->size,1,f);

		//Oe[u0
		sbuf[0]=0;
		if((*jit)->la.empty()){
			//sΉe[uȂ
			sbuf[1]=ChangeBO((short)0);
			fwrite(sbuf,sizeof(short)*2,1,f);
		}
		else{
			//sΉe[u
			sbuf[1]=ChangeBO((short)1);
			fwrite(sbuf,sizeof(short)*2,1,f);

			ofs << "\t[linetable - 0x" << hex << ftell(f) << dec << "]" << endl;

			//LineNumberTablẽAgr[g
			s=ChangeBO((short)ConstantPool_Add(gcp,CP_UTF8,"LineNumberTable"));
			fwrite(&s,sizeof(short),1,f);
			//TCY
			i=ChangeBO((int)((*jit)->la.size()*4+2));
			fwrite(&i,sizeof(int),1,f);
			//e[uTCY
			s=ChangeBO((short)(*jit)->la.size());
			fwrite(&s,sizeof(short),1,f);

			//e[uĂ
			map<int,int>::iterator mit;
			for(mit=(*jit)->la.begin();mit!=(*jit)->la.end();mit++){
				sbuf[0]=ChangeBO((short)((*jit)->vja[mit->second].offset));
				sbuf[1]=ChangeBO((short)mit->first);
				fwrite(sbuf,sizeof(short)*2,1,f);
			}
		}
	}
	
	//Agr[g̓\[Xt@Ĉ
	sbuf[0]=ChangeBO((short)1);
	fwrite(sbuf,sizeof(short),1,f);
	
	//SourceFileAgr[g
	sbuf[0]=ChangeBO((short)ConstantPool_Add(gcp,CP_UTF8,"SourceFile"));
	fwrite(sbuf,sizeof(short),1,f);
	i=ChangeBO((int)2);
	fwrite(&i,sizeof(int),1,f);
	sbuf[0]=ChangeBO((short)ConstantPool_Add(gcp,CP_UTF8,jbcfile));
	fwrite(sbuf,sizeof(short),1,f);
	

//end_1:
	fclose(f);
}




//------------------------------------
//RX^gv[֘A

void Output_ConstantPool(FILE *f,CPData &cp){
	int i;
	float fl;
	short s[2];
	char buf[1024];
	
	buf[0]=(char)cp.tag;
	fwrite(buf,1,1,f);

	switch(cp.tag){
	case CP_UTF8:
		i=sjistoutf8(buf,cp.sval.c_str());
		s[0]=ChangeBO((short)i);
		fwrite(s,sizeof(short),1,f);
		fwrite(buf,i,1,f);
		break;
	case CP_INTEGER:
		//int
		i=ChangeBO(cp.ival[0]);
		fwrite(&i,sizeof(int),1,f);
		break;
	case CP_FLOAT:
		//float
		fl=ChangeBO(cp.fval);
		fwrite(&fl,4,1,f);
		break;
	case CP_CLASS:
	case CP_STRING:
		s[0]=ChangeBO((short)cp.ival[0]);
		fwrite(s,sizeof(short),1,f);
		break;

	case CP_FIELD:
	case CP_METHOD:
	case CP_NAMEANDTYPE:
		s[0]=ChangeBO((short)cp.ival[0]);
		s[1]=ChangeBO((short)cp.ival[1]);
		fwrite(s,sizeof(short)*2,1,f);
		break;
	default:
		ofs << "cp_error";
	}
}


int ConstantPool_Add(ConstantPool& cp,ConstantPoolTag tag,string cps,string cps2,int cpi,float cpf,string cps3){
	int i;
	CPData cpd;
	string ts[2];
	FuncVec::iterator fit;
	Variable *v;
	Function *f;

	cpd.tag=tag;

	switch(tag){
	case CP_UTF8:
		//
		for(i=1;i<cp.size();i++){
			if(cp[i].tag==tag && cp[i].sval==cps) return i;
		}
		cpd.stype="utf8";
		cpd.sval=cps;
		break;

	case CP_INTEGER:
		//int
		for(i=1;i<cp.size();i++){
			if(cp[i].tag==tag && cp[i].ival[0]==cpi) return i;
		}
		cpd.stype="int";
		cpd.ival[0]=cpi;
		break;

	case CP_FLOAT:
		//float
		for(i=1;i<cp.size();i++){
			if(cp[i].tag==tag && cp[i].fval==cpf) return i;
		}
		cpd.stype="float";
		cpd.fval=cpf;
		break;

	case CP_CLASS:
	case CP_STRING:
		//strinĝ邩H
		for(i=1;i<cp.size();i++){
			if(tag==cp[i].tag){
				if(cps==cp[cp[i].ival[0]].sval) return i;
			}
		}
		//ȂΒǉ
		if(tag==CP_CLASS) cpd.stype="class";
		else cpd.stype="string";
		cpd.ival[0]=ConstantPool_Add(cp,CP_UTF8,cps,"",0,0);
		break;

	case CP_FIELD:
		//{IɎ̃tB[hȊOɃANZXȂ
		for(i=1;i<cp.size();i++){
			if(tag==cp[i].tag){
				if(cps==cp[cp[cp[i].ival[1]].ival[0]].sval) return i;
			}
		}
		cpd.stype="field";
		cpd.ival[0]=ConstantPool_Add(cp,CP_CLASS,MyClassName,"",0,0);
		cpd.ival[1]=ConstantPool_Add(cp,CP_NAMEANDTYPE,cps,"",0,0);
		break;

	case CP_METHOD:
		//tB[hTƓl
		for(i=1;i<cp.size();i++){
			if(tag==cp[i].tag){
				//Õ\bh
				if(cps==cp[cp[cp[i].ival[1]].ival[0]].sval){
					//NXv邩H
					if(cps2=="" || cps2==cp[cp[cp[i].ival[0]].ival[0]].sval){
						//^v邩H
						if(cps3=="" || cps3==cp[cp[cp[i].ival[1]].ival[1]].sval) return i;
					}
				}
			}
		}
		cpd.stype="method";

		//tB[hƈقȂARTClassɂ̂Ȃ
		if(cps2!=""){
			cpd.ival[0]=ConstantPool_Add(cp,CP_CLASS,cps2,"",0,0);
			cpd.ival[1]=ConstantPool_Add(cp,CP_NAMEANDTYPE,cps,cps3,0,0);
		}
		else{
			for(fit=gFunc.begin();fit!=gFunc.end();fit++){
				if(cps==(*fit)->name) ts[0]=MyClassName;
			}

			if(ts[0]==""){
				//^CNX猟
				for(fit=RTFunc->begin();fit!=RTFunc->end();fit++){
					if(cps==(*fit)->name) ts[0]="RTClass";
				}
			}
			cpd.ival[0]=ConstantPool_Add(cp,CP_CLASS,ts[0],"",0,0);
			cpd.ival[1]=ConstantPool_Add(cp,CP_NAMEANDTYPE,cps,"",0,0);
		}

		break;

	case CP_NAMEANDTYPE:
		//strinĝ邩H
		for(i=1;i<cp.size();i++){
			if(tag==cp[i].tag){
				//\bhv邩H
				if(cps==cp[cp[i].ival[0]].sval){
					//^̈v`FbN
					if(cps2=="" || cps2==cp[cp[i].ival[1]].sval) return i;
				}
			}
		}

		//܂ϐE\bh쐬Ă
		cpd.stype="name_type";
		cpd.ival[0]=ConstantPool_Add(cp,CP_UTF8,cps,"",0,0);

		//̖O͕ϐ֐H
		if((v=GetVariableFromString(cps,NULL))){
			//Ȃ炱̕ϐ̌^擾
			ts[0]=CreateJavaTypeString(&(v->type));
			cpd.ival[1]=ConstantPool_Add(cp,CP_UTF8,ts[0],"",0,0);
		}
		else if((f=GetFunctionFromString(cps))){
			//Ȃ炱̊֐̌^擾
			ts[0]=CreateJavaTypeString(f);
			cpd.ival[1]=ConstantPool_Add(cp,CP_UTF8,ts[0],"",0,0);
		}
		else{
			//ȂȂvoid
			if(cps2=="") ts[0]="()V";
			else ts[0]=cps2;
			cpd.ival[1]=ConstantPool_Add(cp,CP_UTF8,ts[0],"",0,0);
		}
		break;
	}
	cp.push_back(cpd);
	return cp.size()-1;
}
