
#include "jbc.h"

//------------------------------------------------
//^`FbN
//------------------------------------------------


bool CheckType(){
	FuncVec::iterator fit;
	StmtVec::iterator sit;
	Function *f;

	ErrList.clear();
	
	CheckType_VarArray(*gVarlist,NULL);

	//֐ƂɃ`FbN
	for(fit=gFunc.begin();fit!=gFunc.end();fit++){
		f=*fit;

		//ϐ`̔z`FbN
		CheckType_VarArray(f->args,f);
		CheckType_VarArray(f->vl,f);

		//֐̊eɂă`FbN
		for(sit=f->plist.begin();sit!=f->plist.end();sit++){
			CheckType_Statement(*sit,f);
		}
	}
	
	//G[false
	return (ErrList.size()==0);
}


//z`FbN
void CheckType_VarArray(Varlist &vl,Function* f){
	Varlist::iterator vit;
	string name;
	int i,ci,di,dim;
	char buf[256];

	for(vit=vl.begin();vit!=vl.end();vit++){
		ci=di=0;
		dim=1;
		for(i=0;i<(*vit)->type.arraydepth.size();i++){
			if((*vit)->type.arraydepth[i]==-1) di++;
			else{
				ci++;
				dim*=(*vit)->type.arraydepth[i];
			}
		}

		if(ci>0 && di>0){
			if(f){
				sprintf(buf,"Error [%d]\t֐[ %s ]̕ϐ[ %s ]̔z̗vf"
					"ÓIvfƓIvf݂Ă܂B",(*vit)->lineno,f->name.c_str(),(*vit)->name.c_str());
			}
			else{
				sprintf(buf,"Error [%d]\tO[oϐ[ %s ]̔z̗vf"
					"ÓIvfƓIvf݂Ă܂B",(*vit)->lineno,(*vit)->name.c_str());
			}
			ErrList.push_back(buf);
		}
		else if(dim>MAX_ARRAYSIZE){
			if(f){
				sprintf(buf,"Error [%d]\t֐[ %s ]̕ϐ[ %s ]̔z̗vf傫܂B",
					(*vit)->lineno,f->name.c_str(),(*vit)->name.c_str());
			}
			else{
				sprintf(buf,"Error [%d]\tO[oϐ[ %s ]̔z̗vf傫܂B",
					(*vit)->lineno,(*vit)->name.c_str());
			}
			ErrList.push_back(buf);
		}

	}

}

//PʂŃ`FbN
void CheckType_Statement(Statement *s,Function *f){
	string fname=f->name,st;
	Function *tf;
	char buf[1024];
	int i;
	Type *t1,*t2,tt;
	ConvTypeResult ctr;
	ExprVec::iterator eit;
	StmtVec::iterator sit;
	Variable *v;


	switch(s->stmttype){
	case T_CALL:
		//-----------------------------------------------------------------
		//CALL
		
		//ΏۂƂȂ֐|C^擾
		tf=GetFunctionFromString(IDlist[s->exprlist[0]->index]);
		//Ȃꍇ
		if(tf==NULL){
			sprintf(buf,"Error [%d]\t֐[ %s ]͒`Ă܂B",s->lineno,IDlist[s->exprlist[0]->index].c_str());
			ErrList.push_back(buf);
			return;
		}

		//̐r
		if(tf->args.size() != s->exprlist.size()-1){
			sprintf(buf,"Error [%d]\t֐[ %s ]̈̐قȂ܂B",s->lineno,IDlist[s->exprlist[0]->index].c_str());
			ErrList.push_back(buf);
			return;
		}
		
		//ƂɃ`FbN
		for(i=0;i<tf->args.size();i++){
			t1=CheckType_Expression(s->exprlist[i+1],f);
			t2=&tf->args[i]->type;
			if(t1==NULL) continue;

			ctr=CheckConvType(t1,t2);

			if(ctr==CT_CANT_CONV){
				sprintf(buf,"Error [%d]\t֐[ %s ]%dԖڂ̈̌^ϊs\łBi%s%sj",s->lineno,IDlist[s->exprlist[0]->index],
					TypeToString(t2).c_str(),TypeToString(t1).c_str());
				ErrList.push_back(buf);

			}
			else if(ctr==CT_CONV){
				//t2convert
				CastExpression(&s->exprlist[i+1],t2);
			}

		}

		break;

	case T_REDIM:
		//-----------------------------------------------------------------
		//Redim

		

		st=IDlist[s->exprlist[0]->index];
		//[J
		v=GetVariableFromString(st,f);
		//O[oϐ
		if(v==NULL) v=GetVariableFromString(st,NULL);

		if(v==NULL){
			sprintf(buf,"Error [%d]\tϐ[ %s ]͒`Ă܂B",s->lineno,st.c_str());
			ErrList.push_back(buf);
			return;
		}

		//ƂĂȂ΂Ȃ
		if(v->type.arraydepth.size()+1 != s->exprlist.size()){
			sprintf(buf,"Error [%d]\tϐ[ %s ]̎REDIMŎw肳ꂽقȂ܂B",s->lineno,st.c_str());
			ErrList.push_back(buf);
			return;
		}


		//Redim͊eڂintɕϊł΂悢
		tt.arraydepth.clear();
		tt.type=T_INT;

		for(eit=s->exprlist.begin()+1;eit!=s->exprlist.end();eit++){
			t1=CheckType_Expression(*eit,f);
			if(t1==NULL) continue;
			
			ctr=CheckConvType(t1,&tt);
			if(ctr==CT_CANT_CONV){
				sprintf(buf,"Error [%d]\tRedim%dԖڂ̈̌^intɕϊs\łBi%s%sj",s->lineno,
					TypeToString(t1).c_str(),TypeToString(&tt).c_str());
				ErrList.push_back(buf);
				return;
			}
			else if(ctr==CT_CONV){
				//ttconvert
				CastExpression(&*eit,&tt);
			}
		}
		break;

	case T_SUBST:
		//-----------------------------------------------------------------
		//

		//ӂƉEӂȂ΂ȂȂ
		t1=CheckType_Expression(s->exprlist[0],f);
		if(t1==NULL) break;
		t2=CheckType_Expression(s->exprlist[1],f);
		if(t2==NULL) break;
					
		ctr=CheckConvType(t2,t1);
		if(ctr==CT_CANT_CONV){
			sprintf(buf,"Error [%d]\ť^ϊs\łBi%s%sj",s->lineno,
				TypeToString(t2).c_str(),TypeToString(t1).c_str());
			ErrList.push_back(buf);
		}
		else if(ctr==CT_CONV){
			//t1convert
			CastExpression(&s->exprlist[1],t1);
		}
		break;

	case T_RETURN:
		//-----------------------------------------------------------------
		//return
		
		//SubłreturnɕԂlsp
		if(f->rettype.type==T_VOID){
			if(s->exprlist.size()>0){
				sprintf(buf,"Error [%d]\t֐%sSubŒ`Ă܂Breturnɒlwł܂B",s->lineno,f->name.c_str());
				ErrList.push_back(buf);
			}
			//SubȂKvȂ
			return;
		}
		
		//Functionł͔złȂreturnɕԂlKv
		if(f->rettype.arraydepth.size()>0 && s->exprlist.size()==0) return;
		if(s->exprlist.size()==0 && f->rettype.type==T_VOID){
			sprintf(buf,"Error [%d]\t֐%sFunctionŒ`Ă܂Breturnɒlw肵ĂB",s->lineno,f->name.c_str());
			ErrList.push_back(buf);
			return;
		}

		//ԂlƊ֐̒`vȂ΂ȂȂ
		t1=CheckType_Expression(s->exprlist[0],f);
		if(t1==NULL) break;
		t2=&f->rettype;
					
		ctr=CheckConvType(t1,t2);
		if(ctr==CT_CANT_CONV){
			sprintf(buf,"Error [%d]\treturň^ϊs\łBi%s%sj",s->lineno,
				TypeToString(t1).c_str(),TypeToString(t2).c_str());
			ErrList.push_back(buf);
		}
		else if(ctr==CT_CONV){
			//t2convert
			CastExpression(&s->exprlist[0],t2);
		}
		break;

	case T_LIST:
		//-----------------------------------------------------------------
		//

		//͂̕ꂼꏈ
		for(sit=s->stmtlist.begin();sit!=s->stmtlist.end();sit++)
			CheckType_Statement(*sit,f);
		break;

	case T_FOR:
		//-----------------------------------------------------------------
		//FOR

		//FOR̕ϐint܂float
		t1=CheckType_Expression(s->exprlist[0],f);
		if(!t1 || s->exprlist[0]->exprtype==T_CALL){
			sprintf(buf,"Error [%d]\tFORɎgpϐsłB",s->lineno);
			ErrList.push_back(buf);
			return;
		}
		if(t1->arraydepth.size()>0){
			sprintf(buf,"Error [%d]\tFORɎgpϐ͔z͎gpł܂B",s->lineno);
			ErrList.push_back(buf);
			return;
		}

		if(t1->type!=T_INT && t1->type!=T_FLOAT){
			sprintf(buf,"Error [%d]\tFORɎgpłϐint܂float݂̂łB",s->lineno);
			ErrList.push_back(buf);
			return;
		}

		//e͂̕ϐƓłȂ΂ȂȂ
		for(eit=s->exprlist.begin()+1;eit!=s->exprlist.end();eit++){
			t2=CheckType_Expression(*eit,f);
			if(t2==NULL) continue;
			
			ctr=CheckConvType(t2,t1);
			if(ctr==CT_CANT_CONV){
				sprintf(buf,"Error [%d]\tFor%dԖڂ̈̌^ϊs\łBi%s%sj",s->lineno,
					TypeToString(t2).c_str(),TypeToString(t1).c_str());
				ErrList.push_back(buf);
				return;
			}
			else if(ctr==CT_CONV){
				//ttconvert
				CastExpression(&*eit,t1);
			}
		}
		
		//for̒g`FbN
		for(sit=s->stmtlist.begin();sit!=s->stmtlist.end();sit++)
			CheckType_Statement(*sit,f);
		break;

	case T_DO:
		//-----------------------------------------------------------------
		//DO LOOP
		
		//ŏƍŌwhilẽ`FbN(BOOL=INTɂł邩)
		for(eit=s->exprlist.begin();eit!=s->exprlist.end();eit++){
			t1=CheckType_Expression(*eit,f);
			tt.arraydepth.clear();
			tt.type=T_INT;

			if(t1==NULL) continue;

			ctr=CheckConvType(t1,&tt);

			if(ctr==CT_CANT_CONV){
				sprintf(buf,"Error [%d]\tDoWhile̒gintɕϊł܂B",s->lineno);
				ErrList.push_back(buf);
			}
			else if(ctr==CT_CONV){
				//ttconvert
				CastExpression(&*eit,&tt);
			}
		}

		//Do̒g`FbN
		for(sit=s->stmtlist.begin();sit!=s->stmtlist.end();sit++)
			CheckType_Statement(*sit,f);
		break;

	case T_IF:
		//-----------------------------------------------------------------
		//IF

		//܂`FbN
		for(eit=s->exprlist.begin();eit!=s->exprlist.end();eit++){
			t1=CheckType_Expression(*eit,f);
			tt.arraydepth.clear();
			tt.type=T_INT;

			if(t1==NULL) continue;

			ctr=CheckConvType(t1,&tt);

			if(ctr==CT_CANT_CONV){
				sprintf(buf,"Error [%d]\tIF̏intɕϊł܂B",s->lineno);
				ErrList.push_back(buf);
			}
			else if(ctr==CT_CONV){
				//ttconvert
				CastExpression(&*eit,&tt);
			}
		}

		//IF̒g`FbN
		for(sit=s->stmtlist.begin();sit!=s->stmtlist.end();sit++)
			CheckType_Statement(*sit,f);
		break;
	
	//Ƃ͏KvȂ
	case T_EXIT:
	case T_CONTINUE:
	default:
		
		break;
	}

	return;
}



//̌^
Type* CheckType_Expression(Expression *e,Function *f){
	Function *tf;
	Variable *v;
	char buf[1024],buf2[256];
	Type *t1,*t2;
	Type ct1,ct2,tt;
	int i;
	ConvTypeResult ctr;
	string s;
	bool b=false;

	switch(e->exprtype){
	case T_ID:
	case T_CALL:
		//-----------------------------------------------
		//֐܂͕ϐ

		s=IDlist[e->index];
		//[J
		v=GetVariableFromString(s,f);
		//O[oϐ
		if(v==NULL) v=GetVariableFromString(s,NULL);
		//֐
		tf=NULL;
		if(v==NULL) tf=GetFunctionFromString(s);

		if(v==NULL && tf==NULL){
			sprintf(buf,"Error [%d]\t֐Eϐ[ %s ]͒`Ă܂B",e->lineno,s.c_str());
			ErrList.push_back(buf);
			return NULL;
		}

		if(v){

			//ȂH
			if(e->elist.size()>v->type.arraydepth.size()+1){
				sprintf(buf,"Error [%d]\tϐ[ %s ]̔z̊ʂłB",e->lineno,IDlist[e->elist[0]->index]);
				ErrList.push_back(buf);
				return NULL;
			}
			
			//z̈intɕϊ\H
			tt.arraydepth.clear();
			tt.type=T_INT;
			for(i=0;i<e->elist.size();i++){
				t1=CheckType_Expression(e->elist[i],f);
				if(t1==NULL) continue;

				ctr=CheckConvType(t1,&tt);

				if(ctr==CT_CANT_CONV){
					sprintf(buf,"Error [%d]\tϐ[ %s ]%dԖڂ̉̌^intɕϊs\łBi%sintj",e->lineno,IDlist[e->elist[0]->index],i+1,
						TypeToString(t1).c_str());
					ErrList.push_back(buf);
					b=true;
				}
				else if(ctr==CT_CONV){
					//ttconvert
					CastExpression(&e->elist[i],&tt);
				}
			}
			if(b) return NULL;
			//z񐔂̐폜
			e->etype.type=v->type.type;
			e->etype.arraydepth.clear();
			for(i=0;i<v->type.arraydepth.size()-e->elist.size();i++) e->etype.arraydepth.push_back(-1);
		}
		else{
			//֐
			e->exprtype=T_CALL;

			//subAEg
			if(tf->rettype.type==T_VOID){
				sprintf(buf,"Error [%d]\t֐[ %s ]SubŒ`ĂAlԂ܂B",e->lineno,s.c_str());
				ErrList.push_back(buf);
				return NULL;
			}


			//̐v邩H
			if(e->elist.size()!=tf->args.size()){
				sprintf(buf,"Error [%d]\t֐[ %s ]̈̐قȂ܂B",e->lineno,s.c_str());
				ErrList.push_back(buf);
				return NULL;
			}

			//eŃ`FbN

			for(i=0;i<tf->args.size();i++){
				t1=CheckType_Expression(e->elist[i],f);
				t2=&f->args[i]->type;
				if(t1==NULL) continue;

				ctr=CheckConvType(t1,t2);

				if(ctr==CT_CANT_CONV){
					sprintf(buf,"Error [%d]\t֐[ %s ]%dԖڂ̈̌^ϊs\łBi%s%sj",e->lineno,IDlist[e->elist[0]->index],
						TypeToString(t2).c_str(),TypeToString(t1).c_str());
					ErrList.push_back(buf);
					b=true;
				}
				else if(ctr==CT_CONV){
					//ttconvert
					CastExpression(&e->elist[i],t2);
				}
			}
			if(b) return NULL;
			e->etype.arraydepth.clear();
			e->etype.type=tf->rettype.type;
			
		}
		return &e->etype;
		break;

	case T_CONST:
		//-----------------------------------------------
		//֐܂͕ϐ
		e->etype.type=e->type;
		e->etype.arraydepth.clear();
		return &e->etype;
		
	case T_OP2:
		//-----------------------------------------------
		//2Zq
		t1=CheckType_Expression(e->elist[0],f);
		t2=CheckType_Expression(e->elist[1],f);
		if(t1==NULL || t2==NULL) return NULL;

		if(t1->arraydepth.size()+t2->arraydepth.size()>0 || t1->type==T_VOID || t2->type==T_VOID){
			buf2[0]=0;
			for(i=0;i<sizeof(OPTable)/sizeof(OpTable);i++){
				if(e->type==OPTable[i].index) strcpy(buf2,OPTable[i].str);
			}

			sprintf(buf,"Error [%d]\t[ %s ]Zq̓XJ[l̂ݗp\łBz͗pł܂B",e->lineno,buf2);
			ErrList.push_back(buf);
			return NULL;
		}
		e->etype.arraydepth.clear();
		tt.arraydepth.clear();

		switch(e->type){
		//ZyєrZ͍E̕΂悢
		case T_PLUS:
		case T_EQ:
		case T_NE:
		case T_LT:
		case T_LE:
		case T_GT:
		case T_GE:
			//vĂȂ炻ł悢
			if(t1->type!=t2->type){
				if(t1->type==T_STRING || t2->type==T_STRING){
					//ǂ炩stringȂ炻ɍ킹
					tt.type=T_STRING;
					if(t1->type!=T_STRING) CastExpression(&e->elist[0],&tt);
					//StringBufferőΉł̂ŕKvȂ
					//if(t2->type!=T_STRING) CastExpression(&e->elist[1],&tt);
				}
				else{
					//łȂT_FLOATɍ킹
					tt.type=T_FLOAT;
					if(t1->type!=T_FLOAT) CastExpression(&e->elist[0],&tt);
					if(t2->type!=T_FLOAT) CastExpression(&e->elist[1],&tt);
				}
			}
			else tt.type=t1->type;

			//ʂ͔rȊOint
			if(e->type==T_PLUS) e->etype.type=tt.type;
			else e->etype.type=T_INT;
			break;
		
		//ZȊOstringɂ͓KpȂ
		//IyhlłꏏɂȂ̂
		//-*/% 
		case T_MINUS:
		case T_MULT:
		case T_DIV:
		case T_MOD:
			if(t1->type==t2->type){
				//ꏏȂstringfloatɂȊOKvȂ
				tt.type=t1->type;
				if(t1->type==T_STRING){
					tt.type=T_FLOAT;
					CastExpression(&e->elist[0],&tt);
					CastExpression(&e->elist[1],&tt);
				}
				
				e->etype.type=tt.type;
			}
			else{
				//قȂȂAstring͂łȂقɍ킹
				if(t1->type==T_STRING){
					CastExpression(&e->elist[0],t2);
					e->etype.type=t2->type;
				}
				else if(t2->type==T_STRING){
					CastExpression(&e->elist[1],t1);
					e->etype.type=t1->type;
				}
				//ǂstringłȂȂ痼float
				else{
					tt.type=T_FLOAT;
					if(t1->type!=T_FLOAT) CastExpression(&e->elist[0],&tt);
					if(t2->type!=T_FLOAT) CastExpression(&e->elist[1],&tt);
					e->etype.type=T_FLOAT;
				}
			}
			break;
		
		//rbgZ͂Ƃint
		case T_LSHIFT:
		case T_RSHIFT:
		case T_BITOR:
		case T_BITAND:
		case T_BITXOR:
		case T_BOOLOR:
		case T_BOOLAND:
		case T_BOOLXOR:
			tt.type=T_INT;
			if(t1->type!=T_INT) CastExpression(&e->elist[0],&tt);
			if(t2->type!=T_INT) CastExpression(&e->elist[1],&tt);
			e->etype.type=T_INT;
		}

		return &e->etype;
		break;


	case T_OP1:
		//-----------------------------------------------
		//PZq
		t1=CheckType_Expression(e->elist[0],f);
		if(t1==NULL) return NULL;
		if(t1->arraydepth.size()>0){
			buf2[0]=0;
			for(i=0;i<sizeof(OPTable)/sizeof(OpTable);i++){
				if(e->type==OPTable[i].index) strcpy(buf2,OPTable[i].str);
			}

			sprintf(buf,"Error [%d]\t[ %s ]PZq̓XJ[l̂ݗp\łBz͗pł܂B",e->lineno,buf2);
			ErrList.push_back(buf);
			return NULL;
		}

		e->etype.arraydepth.clear();
		switch(e->type){
		case T_NEG:
			//P}CiX
			//stringfloatɃLXg
			//intEfloat͂̂܂
			if(t1->type==T_STRING){
				tt.arraydepth.clear();
				tt.type=T_FLOAT;
				CastExpression(&e->elist[0],&tt);
				e->etype.type=T_FLOAT;
			}
			else e->etype.type=t1->type;
			break;

		case T_BITNOT:
		case T_BOOLNOT:
			//rbgZ͂ƂINTɑ΂ēKp
			//intȊO̓LXg
			if(t1->type!=T_INT){
				tt.arraydepth.clear();
				tt.type=T_INT;
				CastExpression(&e->elist[0],&tt);
			}
			e->etype.type=T_INT;
			break;
			
		default:
			break;
		}

		return &e->etype;
		break;

	case T_TYPE:
		//-----------------------------------------------
		//LXg

		t1=CheckType_Expression(e->elist[0],f);
		if(t1==NULL) return NULL;
		
		//int͔z
		if(t1->arraydepth.size()>0 && e->type!=T_INT){
			sprintf(buf,"Error [%d]\tzintȊOɂ̓LXgł܂");
			ErrList.push_back(buf);
			return NULL;
		}
		e->etype.type=e->type;
		e->etype.arraydepth.clear();
		return &e->etype;
		break;

	default:
		break;
	}
	

	return NULL;
}

//tfttɌ^ϊ\H
ConvTypeResult CheckConvType(Type *tf,Type *tt){
	//z̃TCYႦ΃AEg
	if(tf->arraydepth.size() != tt->arraydepth.size()) return CT_CANT_CONV;

	if(tf->arraydepth.size()>0){
		//vOK
		return (tf->type==tt->type ? CT_OK : CT_CANT_CONV);
	}
	else{
		//łintAfloatAstring̕ϊ͉\
		return (tf->type==tt->type ? CT_OK : CT_CONV);
	}
}

//exprcast킹
void CastExpression(Expression** e,Type *t){
	Expression *ne;
	char buf[256];
	
	//Ɍ^ꏏȂOK
	if((*e)->etype.type==t->type) return;

	//CONSTȂ璼ڒl
	if((*e)->exprtype==T_CONST){
		ne=*e;
		if(ne->type==T_INT && t->type==T_FLOAT)	ne->fval=(float)ne->ival;
		else if(ne->type==T_FLOAT && t->type==T_INT) ne->ival=(int)ne->fval;
		else if(ne->type==T_STRING && t->type==T_INT)	ne->ival=atoi(Strlist[ne->index].c_str());
		else if(ne->type==T_STRING && t->type==T_FLOAT)	ne->fval=(float)atof(Strlist[ne->index].c_str());
		else if(ne->type==T_INT && t->type==T_STRING){
			sprintf(buf,"%d",ne->ival);
			ne->index=GetIndexfromIDList(&Strlist,buf);
		}
		else if(ne->type==T_FLOAT && t->type==T_STRING){
			sprintf(buf,"%f",ne->fval);
			ne->index=GetIndexfromIDList(&Strlist,buf);
		}
		else{
			sprintf(buf,"Error H");
			ErrList.push_back(buf);
		}

		ne->type=ne->etype.type=t->type;
		return;
	}
	else{
		
		ne=new Expression;
		
		ne->lineno=(*e)->lineno;
		ne->exprtype=T_TYPE;
		ne->type=t->type;
		ne->elist.push_back(*e);
		*e=ne;
	}
}
